
// FindFilesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "framework.h"
#include "FindFiles.h"
#include "FindFilesDlg.h"
#include "afxdialogex.h"
#include <string>

#include "DlgMacros.h"

const char* g_profile_file = 0;

#define TIMER_ID_SAVE 1000
#define TIMER_ID_RELOAD 1001

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CFindFilesDlg dialog



CFindFilesDlg::CFindFilesDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_FINDFILES_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFindFilesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_Before, m_Before);
	DDX_Control(pDX, IDC_After, m_After);
}

BEGIN_MESSAGE_MAP(CFindFilesDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SelectDirectory, &CFindFilesDlg::OnBnClickedSelectdirectory)
	ON_EN_CHANGE(IDC_Directory, &CFindFilesDlg::OnEnChangeDirectory)
	ON_EN_CHANGE(IDC_LargerThan, &CFindFilesDlg::OnEnChangeLargerthan)
	ON_EN_CHANGE(IDC_Filter, &CFindFilesDlg::OnEnChangeFilter)
	ON_EN_CHANGE(IDC_SmallerThan, &CFindFilesDlg::OnEnChangeSmallerthan)
	ON_CBN_SELCHANGE(IDC_LargerThanUnits, &CFindFilesDlg::OnCbnSelchangeLargerthanunits)
	ON_CBN_SELCHANGE(IDC_SmallerThanUnits, &CFindFilesDlg::OnCbnSelchangeSmallerthanunits)
	ON_BN_CLICKED(IDC_TextSearch, &CFindFilesDlg::OnBnClickedTextsearch)
	ON_BN_CLICKED(IDC_Report, &CFindFilesDlg::OnBnClickedReport)
	ON_BN_CLICKED(IDC_Open, &CFindFilesDlg::OnBnClickedOpen)
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_SearchText, &CFindFilesDlg::OnEnChangeSearchtext)
	ON_BN_CLICKED(IDC_RecursiveSearch, &CFindFilesDlg::OnBnClickedRecursivesearch)
//	ON_WM_SIZE()
	ON_WM_SIZING()
	ON_BN_CLICKED(IDC_UseBefore, &CFindFilesDlg::OnBnClickedUsebefore)
	ON_BN_CLICKED(IDC_UseAfter, &CFindFilesDlg::OnBnClickedUseafter)
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_Before, &CFindFilesDlg::OnDtnDatetimechangeBefore)
	ON_NOTIFY(DTN_DATETIMECHANGE, IDC_After, &CFindFilesDlg::OnDtnDatetimechangeAfter)
	ON_LBN_SELCHANGE(IDC_Files, &CFindFilesDlg::OnLbnSelchangeFiles)
	ON_BN_CLICKED(IDC_Delete, &CFindFilesDlg::OnBnClickedDelete)
	ON_BN_CLICKED(IDC_Stop, &CFindFilesDlg::OnBnClickedStop)
END_MESSAGE_MAP()


// CFindFilesDlg message handlers

BOOL CFindFilesDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	char path[MAX_PATH];
	memset(path, 0, sizeof(path));
	::SHGetFolderPath(NULL, CSIDL_COMMON_DOCUMENTS, 0, SHGFP_TYPE_CURRENT, path);

	STRING data_dir;
	data_dir = path;
	data_dir += "\\FindFiles";
	if (_access(data_dir, 00))
	{
		_mkdir(data_dir);
	}

	static STRING profile_file;
	profile_file.SetValidFileName(data_dir, "FindFiles.ini");

	g_profile_file = profile_file;

	LoadFromProfile();

	WINDOWPLACEMENT wp;
	GetWindowPlacement(&wp);

	wp.rcNormalPosition.right = wp.rcNormalPosition.left + 750;
	wp.rcNormalPosition.bottom = wp.rcNormalPosition.top + 830;

	SetWindowPlacement(&wp);

	alignment();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFindFilesDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFindFilesDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFindFilesDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CFindFilesDlg::OnBnClickedSelectdirectory()
{
	BROWSE_FOR_FOLDER(IDC_Directory, "Select directory to begin file search.");
}


void CFindFilesDlg::OnEnChangeDirectory()
{
	TriggerReload();
}


void CFindFilesDlg::OnEnChangeLargerthan()
{
	TriggerReload();
}


void CFindFilesDlg::OnEnChangeFilter()
{
	TriggerReload();
}


void CFindFilesDlg::OnEnChangeSmallerthan()
{
	TriggerReload();
}


void CFindFilesDlg::OnCbnSelchangeLargerthanunits()
{
	TriggerReload();
}


void CFindFilesDlg::OnCbnSelchangeSmallerthanunits()
{
	TriggerReload();
}

void CFindFilesDlg::OnEnChangeSearchtext()
{
	TriggerSave();
}

void CFindFilesDlg::OnBnClickedRecursivesearch()
{
	TriggerReload();
}


void CFindFilesDlg::OnTimer(UINT_PTR nIDEvent)
{
	if (nIDEvent == TIMER_ID_SAVE)
	{
		KillTimer(TIMER_ID_SAVE);
		SaveToProfile();
	}

	if (nIDEvent == TIMER_ID_RELOAD)
	{
		KillTimer(TIMER_ID_RELOAD);
		ReloadFileNames();
	}

	CDialogEx::OnTimer(nIDEvent);
}

bool CFindFilesDlg::TriggerSave(void)
{
	KillTimer(TIMER_ID_SAVE);
	SetTimer(TIMER_ID_SAVE, 1000, NULL);
	return true;
}

bool CFindFilesDlg::TriggerReload(void)
{
	KillTimer(TIMER_ID_RELOAD);
	SetTimer(TIMER_ID_RELOAD, 1000, NULL);
	return true;
}

bool CFindFilesDlg::LoadFromProfile(void)
{
	m_inside_load_from_profile = true;

	const char* Section = "CFindFilesDlg";
	LOAD_FROM_PROFILE(Section, "Directory", IDC_Directory);
	LOAD_FROM_PROFILE(Section, "Filter", IDC_Filter);
	LOAD_FROM_PROFILE(Section, "LargerThan", IDC_LargerThan);
	LOAD_FROM_PROFILE(Section, "SmallerThan", IDC_SmallerThan);
	LOAD_FROM_PROFILE(Section, "LargerThanUnits", IDC_LargerThanUnits);
	LOAD_FROM_PROFILE(Section, "SmallerThanUnits", IDC_SmallerThanUnits);
	LOAD_FROM_PROFILE(Section, "SearchText", IDC_SearchText);
	LOAD_CHECK_STATE_FROM_PROFILE(Section, "RecursiveSearch", IDC_RecursiveSearch);

	LOAD_CHECK_STATE_FROM_PROFILE(Section, "UseBefore", IDC_UseBefore);
	LOAD_CHECK_STATE_FROM_PROFILE(Section, "UseAfter", IDC_UseAfter);


	STRING sdate;
	LOAD_FROM_PROFILE_VAR_STRING(Section, "Before", sdate, "");
	if (sdate.Replace("/", ",") == 2)
	{
		int month, day, year;
		if (sscanf_s(sdate, "%ld,%ld,%ld", &month, &day, &year) == 3)
		{
			SYSTEMTIME st;
			ZeroMemory(&st, sizeof(st));
			st.wYear = year;
			st.wMonth = month;
			st.wDay = day;
			m_Before.SetTime(&st);
		}
	}

	LOAD_FROM_PROFILE_VAR_STRING(Section, "After", sdate, "");
	if (sdate.Replace("/", ",") == 2)
	{
		int month, day, year;
		if (sscanf_s(sdate, "%ld,%ld,%ld", &month, &day, &year) == 3)
		{
			SYSTEMTIME st;
			ZeroMemory(&st, sizeof(st));
			st.wYear = year;
			st.wMonth = month;
			st.wDay = day;
			m_After.SetTime(&st);
		}
	}

	STRING s;

	// Default setting for size units is MB
	GET_TEXT(IDC_LargerThanUnits, s);
	if (StrLen(s, TRUE) == 0)
	{
		SET_TEXT(IDC_LargerThanUnits, "MB");
	}

	GET_TEXT(IDC_SmallerThanUnits, s);
	if (StrLen(s, TRUE) == 0)
	{
		SET_TEXT(IDC_SmallerThanUnits, "MB");
	}


	m_inside_load_from_profile = false;

	return true;
}

bool CFindFilesDlg::SaveToProfile(void)
{
	if (m_inside_load_from_profile)
		return false;

	const char* Section = "CFindFilesDlg";
	SAVE_TO_PROFILE(Section, "Directory", IDC_Directory);
	SAVE_TO_PROFILE(Section, "Filter", IDC_Filter);
	SAVE_TO_PROFILE(Section, "LargerThan", IDC_LargerThan);
	SAVE_TO_PROFILE(Section, "SmallerThan", IDC_SmallerThan);
	SAVE_TO_PROFILE(Section, "LargerThanUnits", IDC_LargerThanUnits);
	SAVE_TO_PROFILE(Section, "SmallerThanUnits", IDC_SmallerThanUnits);
	SAVE_TO_PROFILE(Section, "SearchText", IDC_SearchText);
	SAVE_CHECK_STATE_TO_PROFILE(Section, "RecursiveSearch", IDC_RecursiveSearch);

	SAVE_CHECK_STATE_TO_PROFILE(Section, "UseBefore", IDC_UseBefore);
	SAVE_CHECK_STATE_TO_PROFILE(Section, "UseAfter", IDC_UseAfter);
	SAVE_TO_PROFILE(Section, "Before", IDC_Before);
	SAVE_TO_PROFILE(Section, "After", IDC_After);

	return true;
}

static uint64_t s_smaller_than_sz = 0;
static uint64_t s_larger_than_sz = 0;

uint64_t s_before, s_after;
bool s_use_before = false, s_use_after = false;

bool filter_function(const WIN32_FIND_DATA *data)
{
	uint64_t sz = data->nFileSizeLow;

	if (data->nFileSizeHigh)
		sz += ((uint64_t)data->nFileSizeHigh) << 32;

	if (s_smaller_than_sz)
		if (sz >= s_smaller_than_sz)
			return false;

	if (s_larger_than_sz)
		if (sz <= s_larger_than_sz)
			return false;

	uint64_t t = 0;
	if (s_use_before || s_use_after)
		memmove(&t, &data->ftLastWriteTime, sizeof(t));

	if (s_use_before)
	{
		if (t > s_before)
			return false;
	}

	if (s_use_after)
	{
		if (t < s_after)
			return false;
	}

	return true; // don't filter
}

UINT WORKER_THREAD_LoadFileNamesRecursive(void* param)
{
	CFindFilesDlg* dlg = (CFindFilesDlg*)param;

	CString directory, filter;
	STRING err_msg;
	dlg->GetDlgItem(IDC_Directory)->GetWindowTextA(directory);
	dlg->GetDlgItem(IDC_Filter)->GetWindowTextA(filter);

	LOAD_FILE_NAMES_RECURSIVE(dlg->m_hWnd, IDC_Files, directory, filter, 0xFFFF, err_msg, 0, filter_function, &dlg->m_stop);

	LRESULT count = dlg->SendDlgItemMessage(IDC_Files, LB_GETCOUNT);
	char msg[128];
	msg[0] = 0;

	if (count)
		sprintf_s(msg, sizeof(msg), "%lld files found", count);

	dlg->GetDlgItem(IDC_Status)->SetWindowTextA(msg);
	dlg->GetDlgItem(IDC_Stop)->EnableWindow(FALSE);
	dlg->GetDlgItem(IDC_Directory)->EnableWindow(TRUE);
	dlg->GetDlgItem(IDC_Filter)->EnableWindow(TRUE);
	dlg->GetDlgItem(IDC_Before)->EnableWindow(TRUE);
	dlg->GetDlgItem(IDC_After)->EnableWindow(TRUE);
	dlg->GetDlgItem(IDC_UseBefore)->EnableWindow(TRUE);
	dlg->GetDlgItem(IDC_UseAfter)->EnableWindow(TRUE);
	dlg->GetDlgItem(IDC_SmallerThan)->EnableWindow(TRUE);
	dlg->GetDlgItem(IDC_LargerThan)->EnableWindow(TRUE);
	dlg->GetDlgItem(IDC_SmallerThanUnits)->EnableWindow(TRUE);
	dlg->GetDlgItem(IDC_LargerThanUnits)->EnableWindow(TRUE);

	dlg->m_stop = false;

	return 0;
}

bool CFindFilesDlg::ReloadFileNames(void)
{
	STRING units, snum;
	
	s_smaller_than_sz = 0;
	GET_TEXT(IDC_SmallerThan, snum);
	if (sscanf_s(snum, "%llu", &s_smaller_than_sz) == 1)
	{
		GET_TEXT(IDC_SmallerThanUnits, units);

		if (IsEqualTo(units, "KB"))
			s_smaller_than_sz *= 1024;
		else if (IsEqualTo(units, "MB"))
			s_smaller_than_sz *= 1024 * 1024;
		else if (IsEqualTo(units, "GB"))
			s_smaller_than_sz *= 1024 * 1024 * 1024;
	}

	s_larger_than_sz = 0;
	GET_TEXT(IDC_LargerThan, snum);
	if (sscanf_s(snum, "%llu", &s_larger_than_sz) == 1)
	{
		GET_TEXT(IDC_LargerThanUnits, units);

		if (IsEqualTo(units, "KB"))
			s_larger_than_sz *= 1024;
		else if (IsEqualTo(units, "MB"))
			s_larger_than_sz *= 1024 * 1024;
		else if (IsEqualTo(units, "GB"))
			s_larger_than_sz *= 1024 * 1024 * 1024;
	}

	s_use_before = false;
	s_use_after = false;

	if (IS_CHECKED(IDC_UseBefore))
	{
		s_use_before = true;
		SYSTEMTIME st;
		m_Before.GetTime(&st);
		SystemTimeToFileTime(&st, (FILETIME*)&s_before);
	}

	if (IS_CHECKED(IDC_UseAfter))
	{
		s_use_after = true;
		SYSTEMTIME st;
		m_After.GetTime(&st);
		SystemTimeToFileTime(&st, (FILETIME*)&s_after);
	}

	SET_TEXT(IDC_Status, "");

	DISABLE(IDC_Delete);
	DISABLE(IDC_Report);
	DISABLE(IDC_Open);
	DISABLE(IDC_TextSearch);

	DISABLE(IDC_Directory);
	DISABLE(IDC_Filter);
	DISABLE(IDC_Before);
	DISABLE(IDC_After);
	DISABLE(IDC_UseBefore);
	DISABLE(IDC_UseAfter);
	DISABLE(IDC_SmallerThan);
	DISABLE(IDC_LargerThan);
	DISABLE(IDC_SmallerThanUnits);
	DISABLE(IDC_LargerThanUnits);

	ENABLE(IDC_Stop);

	AfxBeginThread(WORKER_THREAD_LoadFileNamesRecursive,this);

	return true;
}

void CFindFilesDlg::OnSizing(UINT fwSide, LPRECT pRect)
{
	CDialogEx::OnSizing(fwSide, pRect);
	
	alignment();
}

void CFindFilesDlg::alignment(void)
{
	int margin = 6;

	CONFORM_RIGHT_SIDE(IDC_Directory, margin, 20);
	CONFORM_RIGHT_SIDE(IDC_Filter, margin, 20);
	CONFORM_RIGHT_SIDE(IDC_SearchText, margin, 20);
	CONFORM_RIGHT_SIDE(IDC_Files, margin, 20);
	CONFORM_BOTTOM_SIDE(IDC_Files, margin, 20);
	CONFORM_RIGHT_SIDE(IDC_Status, margin, 20);
}


void CFindFilesDlg::OnBnClickedUsebefore()
{
	TriggerSave();
	TriggerReload();
}


void CFindFilesDlg::OnBnClickedUseafter()
{
	TriggerSave();
	TriggerReload();
}


void CFindFilesDlg::OnDtnDatetimechangeBefore(NMHDR* pNMHDR, LRESULT* pResult)
{
	LPNMDATETIMECHANGE pDTChange = reinterpret_cast<LPNMDATETIMECHANGE>(pNMHDR);

	STRING s;
	GET_TEXT(IDC_Before, s);

	TriggerSave();
	if (IS_CHECKED(IDC_UseBefore)) TriggerReload();

	*pResult = 0;
}


void CFindFilesDlg::OnDtnDatetimechangeAfter(NMHDR* pNMHDR, LRESULT* pResult)
{
	LPNMDATETIMECHANGE pDTChange = reinterpret_cast<LPNMDATETIMECHANGE>(pNMHDR);

	TriggerSave();
	if (IS_CHECKED(IDC_UseAfter)) TriggerReload();

	*pResult = 0;
}


void CFindFilesDlg::OnLbnSelchangeFiles()
{
	int sel_count = SendDlgItemMessage(IDC_Files, LB_GETSELCOUNT);
	if (sel_count == 0)
	{
		DISABLE(IDC_Delete);
		DISABLE(IDC_Report);
		DISABLE(IDC_Open);
		DISABLE(IDC_TextSearch);
	}
	else
	{
		ENABLE(IDC_Delete);
		ENABLE(IDC_Report);
		ENABLE(IDC_Open);
		ENABLE(IDC_TextSearch);
	}
}


void CFindFilesDlg::OnBnClickedDelete()
{
	CStringArray files;
	GET_SELECTED_LB_STRINGS(IDC_Files, files);

	CString msg;	
	
	STRING dir;
	CStringArray log;

	GET_TEXT(IDC_Directory, dir);
	for (int i = 0; i < files.GetSize(); i++)
	{
		STRING file_name;
		file_name.SetValidFileName(dir, files[i]);

		if (_access(file_name, 02))
		{
			CString s;
			s.Format("File is locked: %s", (const char*)file_name);
			log.Add(s);
		}
	}

	if (log.GetSize())
	{
		msg = "";
		for (int i = 0; i < min(10,log.GetSize()); i++)
		{
			msg += log[i];
			msg += "\n";
		}
		AfxMessageBox(msg, MB_OK);
		return;
	}

	msg.Format("Are you sure that you want to permenantly delete %ld files", files.GetSize());

	if (AfxMessageBox(msg, MB_YESNO) == IDNO)
		return;

	for (int i = 0; i < files.GetSize(); i++)
	{
		STRING file_name;
		file_name.SetValidFileName(dir, files[i]);

		if (_unlink(file_name))
		{
			CString s;
			s.Format("Problem deleting: %s", (const char*)file_name);
			log.Add(s);
			if (log.GetSize() >= 10)
				break;
		}
	}

	if (log.GetSize())
	{
		msg = "";
		for (int i = 0; i < min(10, log.GetSize()); i++)
		{
			msg += log[i];
			msg += "\n";
		}
		AfxMessageBox(msg, MB_OK);
	}

	TriggerReload();
}


void CFindFilesDlg::OnBnClickedStop()
{
	m_stop = true;
}

void CFindFilesDlg::OnBnClickedReport()
{
	CStringArray files;
	GET_SELECTED_LB_STRINGS(IDC_Files, files);

	CString msg;

	STRING dir;
	CStringArray log;

	log.Add("file\tsize\tDate\tTime");

	uint64_t total_sz = 0;

	GET_TEXT(IDC_Directory, dir);
	for (int i = 0; i < files.GetSize(); i++)
	{
		STRING file_name;
		file_name.SetValidFileName(dir, files[i]);

		WIN32_FIND_DATA data;
		HANDLE h = FindFirstFile(file_name, &data);

		if (h == INVALID_HANDLE_VALUE)
		{
			msg.Format("%s\tUnable to access", (const char*)file_name);
			log.Add(msg);
			continue;
		}

		FindClose(h);

		SYSTEMTIME st;
		FileTimeToSystemTime(&data.ftLastWriteTime, &st);

		union
		{
			uint64_t sz;
			DWORD wsz[2];
		};

		wsz[0] = data.nFileSizeLow;
		wsz[1] = data.nFileSizeHigh;

		total_sz += sz;

		msg.Format("%s\t%lld\t%04u/%02u/%2u\t%02u:%02u:%02u", (const char*)file_name, sz, st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond);
		log.Add(msg);
	}

	STRING tmp_file;
	tmp_file.LoadFileName(g_profile_file, TRUE, FALSE, FALSE);
	tmp_file += "report.txt";

	FILE* stream = 0;
	fopen_s(&stream, tmp_file, "w");
	if (!stream)
	{
		msg.Format("Unable to create file: %s", (const char*)tmp_file);
		AfxMessageBox(msg, MB_OK);
		return;
	}

	fprintf_s(stream, "*********  Find Files Report *************\n");
	fprintf_s(stream, "NumFiles\t%lld\n", files.GetSize());

	CString mb;
	if (total_sz > 1024 * 200)
	{
		mb.Format("%3.1lf MB", (double)total_sz / (1024 * 1024));
	}

	fprintf_s(stream, "TotalSizeBytes\t%lld\t%s\n", total_sz, (const char *)mb);
	fprintf_s(stream, "******************************************\n");

	for (int i = 0; i < log.GetSize(); i++)
	{
		fprintf_s(stream, "%s\n", (const char *)log[i]);
	}

	fclose(stream);

	OpenFileUsingDefaultApp(tmp_file);
}

void CFindFilesDlg::OnBnClickedOpen()
{
	CStringArray files;

	GET_SELECTED_LB_STRINGS(IDC_Files, files);

	STRING dir;
	GET_TEXT(IDC_Directory, dir);

	for (int i = 0; i < files.GetSize(); i++)
	{
		STRING file_name;
		file_name.SetValidFileName(dir, files[i]);

		OpenFileUsingDefaultApp(file_name);
	}
}

void CFindFilesDlg::OnBnClickedTextsearch()
{
	STRING text;
	GET_TEXT(IDC_SearchText, text);

	int len = StrLen(text);

	if (StrLen(text, TRUE) == FALSE)
		return;

	CStringArray files, log;
	CString msg;

	GET_SELECTED_LB_STRINGS(IDC_Files, files);

	STRING dir;
	GET_TEXT(IDC_Directory, dir);

	vector<char> buffer;
	buffer.resize(20 * 1024 * 1024); // 20 MB buffer

	for (int i = 0; i < files.GetSize(); i++)
	{
		STRING file_name;
		file_name.SetValidFileName(dir, files[i]);

		WIN32_FIND_DATA data;
		HANDLE h = FindFirstFile(file_name, &data);

		if (h == INVALID_HANDLE_VALUE)
		{
			msg.Format("%s\tUnable to access", (const char*)file_name);
			log.Add(msg);
			continue;
		}

		FindClose(h);

		union
		{
			uint64_t sz;
			DWORD wsz[2];
		};

		wsz[0] = data.nFileSizeLow;
		wsz[1] = data.nFileSizeHigh;

		if (sz < len)
			continue;

		FILE* stream = 0;
		fopen_s(&stream, file_name, "rb");
		if (stream == 0)
		{
			msg.Format("%s\tProblem opening file.", (const char*)file_name);
			log.Add(msg);
			continue;
		}

		size_t n = min(buffer.size(), sz);

		size_t nread = fread(&buffer[0], 1, n, stream);
		if (nread != n)
		{
			msg.Format("%s\tProblem reading file.", (const char*)file_name);
			log.Add(msg);
			fclose(stream);
			continue;
		}

		for (uint64_t i = 0; i < n - len - 1; i++)
		{
			int idx = 0;
			for (uint64_t j = i; j < i + len; j++)
			{
				if (buffer[j] != text[idx++])
					break;
			}

			if (idx == len)
			{
				msg.Format("%s\tText found.", (const char *)file_name);
				log.Add(msg);
			}
		}

		fclose(stream);
	}


	STRING tmp_file;
	tmp_file.LoadFileName(g_profile_file, TRUE, FALSE, FALSE);
	tmp_file += "find.txt";

	FILE *stream = 0;
	fopen_s(&stream, tmp_file, "w");
	if (!stream)
	{
		msg.Format("Unable to create file: %s", (const char*)tmp_file);
		AfxMessageBox(msg, MB_OK);
		return;
	}

	fprintf_s(stream, "*********  Find Text Report **************\n");
	fprintf_s(stream, "search_text=\"%s\"\n", (const char *)text);
	fprintf_s(stream, "File\tStatus\n");

	if (log.GetSize() == 0)
		fprintf_s(stream, "Text not found in any of the selected files.\n");
	else
	{
		for (int i = 0; i < log.GetSize(); i++)
			fprintf_s(stream, "%s\n", (const char*)log[i]);
	}
	
	fclose(stream);

	OpenFileUsingDefaultApp(tmp_file);
}


