#include "CommDlg.h"

#pragma once

namespace WorkbenchLib
{
	BOOL SelectDirectory(STRING &dir, const char *title, const char *root_folder = 0);
};

#define SET_TEXT(IDC,s)\
{\
	CWnd *__wnd__ = GetDlgItem (IDC);\
	if (__wnd__ && (const char *)s)\
		{\
		__wnd__->SetWindowText (s);\
		}\
}

#ifdef _MFC_VER
inline void _SET_TEXT(UINT IDC, const char *s, CWnd *dlg)
{
	CWnd *wnd = dlg->GetDlgItem(IDC);
	if (wnd && (const char *)s)
	{
		wnd->SetWindowText(s);
	}
}
#endif

#define SET_TEXT_double(IDC,k)\
{\
	char __tmp__[64]; \
	sprintf_s(__tmp__, sizeof(__tmp__), "%lf", k); \
	SET_TEXT(IDC, __tmp__)\
}

#define SET_TEXT_int(IDC,k)\
{\
	char __tmp__[64];\
	sprintf_s(__tmp__, sizeof(__tmp__), "%" SCNd32 "", k); \
	SET_TEXT(IDC,__tmp__)\
}

#define GET_TEXT(IDC,s)\
{\
	CWnd *__wnd__ = GetDlgItem (IDC);\
	if (__wnd__)\
		{\
		char __s0__[1024];\
		__s0__[0] = 0;\
		__wnd__->GetWindowText (__s0__,1023);\
		s = __s0__;\
		}\
}

inline void GET_TEXT_h(HWND hDlg, UINT IDC, STRING &s)
{
	HWND h = GetDlgItem(hDlg, IDC);
	if (IsWindow(h))
	{
		char s0[1024];
		s0[0] = 0;
		GetWindowText(h, s0, 1023);
		s = s0;
	}
}
inline void SET_TEXT_h(HWND hDlg, UINT IDC, const char *s)
{
	HWND h = GetDlgItem(hDlg, IDC);
	if (IsWindow(h))
		SetWindowText(h, s);
}


#define GET_TEXT_HDLG(hdlg,IDC,s)\
{\
	HWND h = ::GetDlgItem(hdlg,IDC); \
	if (::IsWindow(h))\
		{\
		char __s0__[1024]; \
		__s0__[0] = 0; \
		::GetWindowText(h,__s0__, 1023); \
		s = __s0__; \
		}\
}



inline void GET_TEXT_func(HWND hwnd, WORD idc, STRING &s)
{
	HWND __wnd__ = GetDlgItem(hwnd, idc);
	if (::IsWindow(__wnd__))
	{
		char __s0__[1024];
		__s0__[0] = 0;
		GetWindowText(__wnd__, __s0__, 1023);
		s = __s0__;
	}
}

#ifdef _MFC_VER
inline void _GET_TEXT(UINT IDC, CString &s, CWnd *dlg)
{
	CWnd *wnd = dlg->GetDlgItem(IDC);
	if (wnd)
	{
		char s0[1024];
		s0[0] = 0;
		wnd->GetWindowText(s0, 1023);
		s = s0;
	}
}
#endif

#define SET_TEXT_EXTERN(DLG,IDC,s)\
{\
	CWnd *wnd = DLG.GetDlgItem (IDC);\
	if (wnd)\
			{\
		wnd->SetWindowText (s);\
			}\
}

#define GET_TEXT_EXTERN(DLG,IDC,s)\
{\
	CWnd *wnd = DLG.GetDlgItem (IDC);\
	if (wnd))\
			{\
		char s0[1024];\
		s0[0] = 0;\
		wnd->GetWindowText (s0,1023);\
		s = s0;\
			}\
}

#define SET_TEXT_VAR(IDC,v)\
{\
STRING s = v; \
SET_TEXT(IDC, (const char *)s);\
}


#define GET_TEXT_float_ex(IDC,v,v_def)\
{\
	CString s;\
	GET_TEXT(IDC,s)\
	if (sscanf_s ((const char *)s,"%f",&v) == 0)\
				{\
		v = v_def;\
				}\
}

#define GET_TEXT_double_ex(IDC,v,v_def)\
{\
	CString s;\
	GET_TEXT(IDC,s)\
	if (sscanf_s ((const char *)s,"%lf",&v) == 0)\
				{\
		v = v_def;\
				}\
}

#define GET_TEXT_double(IDC,v)\
{\
	CString s;\
	GET_TEXT(IDC,s)\
	sscanf_s ((const char *)s,"%lf",&v);\
}

#define GET_TEXT_int(IDC,v)\
{\
	CString s;\
	GET_TEXT(IDC,s)\
	sscanf_s ((const char *)s,"%" SCNd32 "",&v);\
}

#define GET_TEXT_int_ex(IDC,v,v_def)\
{\
	CString s;\
	GET_TEXT(IDC,s)\
	if (sscanf_s ((const char *)s,"%" SCNd32 "",&v) != 1) v = v_def;\
}

#define DISABLE(IDC)\
{\
	CWnd *wnd = GetDlgItem (IDC);\
	if (wnd)\
		{\
		wnd->EnableWindow(FALSE);\
		}\
}

#define ENABLE(IDC)\
{\
	CWnd *wnd = GetDlgItem (IDC);\
	if (wnd)\
		{\
		wnd->EnableWindow(TRUE);\
		}\
}

#define LOAD_FOLDER_NAMES(IDC_LB,IDC_Path) \
{\
	SendDlgItemMessage (IDC_LB,LB_RESETCONTENT);\
\
	CString path;\
	GET_TEXT(IDC_Path,path);\
	STRING path_spec;\
	path_spec.SetValidFileName (path,"*");\
\
	WIN32_FIND_DATA data;\
\
	HANDLE h = FindFirstFile(path_spec,&data);\
\
	if (h == INVALID_HANDLE_VALUE) \
		return FALSE;\
\
		while (1)\
			{\
					while (data.dwFileAttributes | FILE_ATTRIBUTE_DIRECTORY)\
							{\
			if (data.cFileName[0] == '.' && data.cFileName[1] == 0)\
				break;\
\
			if (data.cFileName[0] == '.' && data.cFileName[1] == '.' && data.cFileName[2] == 0)\
				break;\
\
			if ((data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) == 0)\
				break;\
\
			SendDlgItemMessage (IDC_LB,LB_ADDSTRING,NULL,(LPARAM)data.cFileName);\
			break;\
							}\
\
		if (FindNextFile (h,&data) != TRUE)\
			break;\
			}\
\
	FindClose(h);\
}

#define LOAD_FILE_NAMES(IDC_LB,path,ext) \
while (1)\
{\
	SendDlgItemMessage (IDC_LB,LB_RESETCONTENT);\
\
	STRING path_spec;\
	path_spec.SetValidFileName (path,ext);\
\
	WIN32_FIND_DATA data;\
\
	HANDLE h = FindFirstFile(path_spec,&data);\
\
	if (h == INVALID_HANDLE_VALUE) \
		break;\
\
	while (1)\
	{\
		SendDlgItemMessage (IDC_LB,LB_ADDSTRING,NULL,(LPARAM)data.cFileName);\
\
		if (FindNextFile (h,&data) != TRUE)\
			break;\
	}\
\
	FindClose(h);\
	break;\
}

#define LOAD_FILE_NAMES_EXCL_FILTER(IDC_LB,IDC_Path,ext,ex_filter) \
{\
	SendDlgItemMessage (IDC_LB,LB_RESETCONTENT);\
\
	CString path;\
	GET_TEXT(IDC_Path,path);\
	STRING path_spec;\
	path_spec.SetValidFileName (path,ext);\
\
	WIN32_FIND_DATA data;\
\
	HANDLE h = FindFirstFile(path_spec,&data);\
\
	if (h == INVALID_HANDLE_VALUE) \
		return FALSE;\
\
		while (1)\
			{\
		if (StrStr (data.cFileName,ex_filter,FALSE) == 0)\
		    SendDlgItemMessage (IDC_LB,LB_ADDSTRING,NULL,(LPARAM)data.cFileName);\
\
		if (FindNextFile (h,&data) != TRUE)\
			break;\
			}\
\
	FindClose(h);\
}

// options - 0x0001 - get rid of extension before adding to combo box
#define LOAD_FILE_NAMES_CB(IDC_CB,path_spec,options)\
	while (1)\
	{\
	SendDlgItemMessage (IDC_CB,CB_RESETCONTENT);\
\
	WIN32_FIND_DATA data;\
\
	HANDLE h = FindFirstFile(path_spec,&data);\
\
	if (h == INVALID_HANDLE_VALUE) \
		break;\
\
		while (1)\
			{\
		if (options & 0x001) /* Get rid of extension */\
				{\
			char *c = strrchr (data.cFileName,'.');\
			if (c)\
				*c = 0;\
				}\
\
		SendDlgItemMessage (IDC_CB,CB_ADDSTRING,NULL,(LPARAM)data.cFileName);\
\
		if (FindNextFile (h,&data) != TRUE)\
			break;\
			}\
\
	FindClose(h);\
	break;\
	}

#define LOAD_FILE_NAMES_EX(IDC_LB,IDC_Path,IDC_Filter) \
{\
	SendDlgItemMessage (IDC_LB,LB_RESETCONTENT);\
\
	CString path;\
	GET_TEXT(IDC_Path,path);\
	STRING path_spec;\
\
	CString spec;\
	GET_TEXT(IDC_Filter,spec);\
\
	path_spec.SetValidFileName (path,spec);\
\
	WIN32_FIND_DATA data;\
\
	HANDLE h = FindFirstFile(path_spec,&data);\
\
	if (h == INVALID_HANDLE_VALUE) \
		return FALSE;\
\
		while (1)\
			{\
					while (1)\
							{\
			if (IsEqualTo(data.cFileName, ".")) break; \
			if (IsEqualTo(data.cFileName, "..")) break; \
			if (data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) break; \
			SendDlgItemMessage(IDC_LB, LB_ADDSTRING, NULL, (LPARAM)data.cFileName); \
			break; \
							}\
\
		if (FindNextFile (h,&data) != TRUE)\
			break;\
			}\
\
	FindClose(h);\
}

inline bool LOAD_FILE_NAMES_RECURSIVE
(
HWND hdlg, int idc_LB, const char *path, const char *filter,
int max_names,
STRING &err_msg,
const char *parent_path = 0,
bool (filter_function(const WIN32_FIND_DATA *)) = 0,
bool *stop = 0
)
{
	if (parent_path == 0)
		::SendDlgItemMessage(hdlg, idc_LB, LB_RESETCONTENT, NULL, NULL);

	STRING path_spec;

	path_spec.SetValidFileName(path, "*");

	WIN32_FIND_DATA data;

	HANDLE h = FindFirstFile(path_spec, &data);

	if (h == INVALID_HANDLE_VALUE)
		return true;

	while (1)
	{
		while (1)
		{
			if (stop && *stop == true)
				return false;

			if (IsEqualTo(data.cFileName, ".")) break;
			if (IsEqualTo(data.cFileName, "..")) break;
			if (data.dwFileAttributes & FILE_ATTRIBUTE_DEVICE) break;
			if (data.dwFileAttributes & FILE_ATTRIBUTE_COMPRESSED) break;
			if (data.dwFileAttributes & FILE_ATTRIBUTE_HIDDEN) break;
			if (data.dwFileAttributes & FILE_ATTRIBUTE_SYSTEM) break;

			if (data.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			{
				STRING next_path = path;
				next_path.AppendSubDir(data.cFileName);
				STRING next_parent_path;
				if (parent_path == 0)
					next_parent_path = data.cFileName;
				else
				{
					next_parent_path = parent_path;
					next_parent_path.AppendSubDir(data.cFileName);
				}

				HWND hStatus = ::GetDlgItem(hdlg, IDC_Status);
				char status[MAX_PATH + 1];
				if (hStatus)
				{
					::GetWindowText(hStatus, status, sizeof(status) - 1);
					int len_dir_name = StrLen(data.cFileName);
					int len_status = StrLen(status);
					if (len_status + len_dir_name + 1 < sizeof(status) - 1)
					{
						strcat_s(status, "\\");
						strcat_s(status, data.cFileName);
						::SetWindowText(hStatus, status);
					}
				}

				bool ret = LOAD_FILE_NAMES_RECURSIVE(hdlg, idc_LB, next_path, filter, max_names, err_msg, next_parent_path, filter_function, stop);

				if (hStatus)
				{
					char* c = strrchr(status, '\\');
					if (c) *c = 0;
					::SetWindowText(hStatus, status);
				}

				if (ret == false)
				{
					FindClose(h);
					return false;
				}

				break;
			}

			int idx_number;
			if (matches_naming_convention(data.cFileName, filter, idx_number) == FALSE) break;

			if (::SendDlgItemMessage(hdlg, idc_LB, LB_GETCOUNT, NULL, NULL) >= max_names)
			{
				err_msg = "Maximum number for file names have been loaded to the list box: ";
				err_msg += (long)max_names;
				FindClose(h);
				return false;
			}

			if (filter_function)
			{
				if (filter_function(&data) == false)
					break;
			}

			if (parent_path)
			{
				STRING new_item = parent_path;
				new_item.AppendSubDir(data.cFileName);
				::SendDlgItemMessage(hdlg, idc_LB, LB_ADDSTRING, NULL, (LPARAM)new_item.GetStringConst());
			}
			else
				::SendDlgItemMessage(hdlg, idc_LB, LB_ADDSTRING, NULL, (LPARAM)data.cFileName);

			break;
		}

		if (FindNextFile(h, &data) != TRUE)
			break;
	}

	FindClose(h);

	return true;
}

inline void LOAD_FILE_NAMES_EX_func(HWND hwnd, WORD lb_id, WORD path_id, WORD filter_id)
{
	SendDlgItemMessage(hwnd, lb_id, LB_RESETCONTENT, 0, 0);

	STRING path;
	GET_TEXT_func(hwnd, path_id, path);
	STRING path_spec;

	STRING spec;
	GET_TEXT_func(hwnd, filter_id, spec);

	path_spec.SetValidFileName(path, spec);

	WIN32_FIND_DATA data;

	HANDLE h = FindFirstFile(path_spec, &data);

	if (h == INVALID_HANDLE_VALUE)
		return;

	while (1)
	{
		SendDlgItemMessage(hwnd, lb_id, LB_ADDSTRING, NULL, (LPARAM)data.cFileName);

		if (FindNextFile(h, &data) != TRUE)
			break;
	}

	FindClose(h);
}

#define BROWSE_FOR_FOLDER(IDC_Path,title)\
{\
	STRING path;\
	GET_TEXT(IDC_Path,path)\
	if (SelectDirectory(path,title) == TRUE)\
		{\
		SET_TEXT(IDC_Path,path)\
		}\
}

#define BROWSE_FOR_FOLDER_LIST(IDC_LB,title)\
{\
	STRING path;\
	if (SelectDirectory(path,title) == TRUE)\
		{\
		SendDlgItemMessage (IDC_LB,LB_ADDSTRING,NULL,(LPARAM)(const char *)path);\
		}\
}

#define LOAD_FILE_NAMES_EX1(IDC_LB,IDC_Path,filter) \
{\
	SendDlgItemMessage (IDC_LB,LB_RESETCONTENT);\
\
	CString path;\
	GET_TEXT(IDC_Path,path);\
	STRING path_spec;\
\
	CString spec = (const char *)filter;\
	path_spec.SetValidFileName (path,spec);\
\
	WIN32_FIND_DATA data;\
\
	HANDLE h = FindFirstFile(path_spec,&data);\
\
	if (h == INVALID_HANDLE_VALUE) \
		return FALSE;\
\
		while (1)\
			{\
		SendDlgItemMessage (IDC_LB,LB_ADDSTRING,NULL,(LPARAM)data.cFileName);\
\
		if (FindNextFile (h,&data) != TRUE)\
			break;\
			}\
\
	FindClose(h);\
}

#define GET_SELECTED_FILE(IDC_LB,IDC_PATH,idx,file_name)\
				while (1)\
							{\
				if (idx < 0)\
					break;\
\
				int n = SendDlgItemMessage (IDC_LB,LB_GETSELCOUNT);\
\
				if (n <= idx)\
					break;\
\
				if (n < 0)\
					break;\
\
				int *indexes = (int *)alloca (sizeof(int)*n);\
\
				SendDlgItemMessage (IDC_LB,LB_GETSELITEMS,(WPARAM)n,(LPARAM)indexes);\
\
				CString path;\
				GET_TEXT (IDC_PATH,path);\
\
				CString total_err_msg;\
\
				int len = SendDlgItemMessage (IDC_Files,LB_GETTEXTLEN,(WPARAM)indexes[idx]);\
				char *sname = (char *)alloca(len);\
\
				if (!sname)\
					break;\
\
				SendDlgItemMessage (IDC_LB,LB_GETTEXT,(WPARAM)indexes[idx],(LPARAM)sname);\
\
				STRING path_name;\
				path_name.SetValidFileName (path,sname);\
\
				file_name = (const char *) path_name;\
\
				break;\
							}


// For single selection list boxes, str is a CString or a STRING object
#define GET_CARAT_LB_STRING(IDC_LB,str)\
	while (1)\
	{\
	str = "";\
	int i = SendDlgItemMessage (IDC_LB,LB_GETCARETINDEX );\
	if (i < 0)\
		break;\
\
	int len = SendDlgItemMessage (IDC_LB,LB_GETTEXTLEN,(WPARAM)i);\
	if (len <= 0)\
		break;\
\
	char *s = new char[len+1];\
	if (!s)\
		{\
		break;\
		}\
\
	SendDlgItemMessage (IDC_LB,LB_GETTEXT,(WPARAM)i,(LPARAM)s);\
	str = s;\
	delete [] s;\
	break;\
	}

// For single selection list boxes, str is a CString or a STRING object
#define GET_SELECTED_LB_STRING(IDC_LB,str)\
	while (1)\
	{\
	str = "";\
	int i = SendDlgItemMessage (IDC_LB,LB_GETCURSEL);\
	if (i < 0)\
		break;\
\
	int len = SendDlgItemMessage (IDC_LB,LB_GETTEXTLEN,(WPARAM)i);\
	if (len <= 0)\
		break;\
\
	char *s = new char[len+1];\
	if (!s)\
		{\
		break;\
		}\
\
	SendDlgItemMessage (IDC_LB,LB_GETTEXT,(WPARAM)i,(LPARAM)s);\
	str = s;\
	delete [] s;\
	break;\
	}

// For single selection list boxes, str is a CString or a STRING object
// returns the data item for the selected string
#define GET_SELECTED_LB_STRING_EX(IDC_LB,str,data)\
	while (1)\
	{\
	str = "";\
	int i = SendDlgItemMessage (IDC_LB,LB_GETCURSEL);\
	if (i < 0)\
		break;\
\
	int len = SendDlgItemMessage (IDC_LB,LB_GETTEXTLEN,(WPARAM)i);\
	if (len <= 0)\
		break;\
\
	char *s = new char[len+1];\
	if (!s)\
		{\
		break;\
		}\
\
	SendDlgItemMessage (IDC_LB,LB_GETTEXT,(WPARAM)i,(LPARAM)s);\
	str = s;\
\
	data = SendDlgItemMessage (IDC_LB,LB_GETITEMDATA,(WPARAM)i);\
	delete [] s;\
	break;\
	}

// For single selection list boxes, str is a CString or a STRING object
#define GET_SELECTED_CB_STRING(IDC_CB,str)\
	while (1)\
	{\
	str = "";\
	int i = SendDlgItemMessage (IDC_CB,CB_GETCURSEL);\
	if (i < 0)\
		break;\
\
	int len = SendDlgItemMessage (IDC_CB,CB_GETLBTEXTLEN,(WPARAM)i);\
	if (len <= 0)\
		break;\
\
	char *s = new char[len+1];\
	if (!s)\
		{\
		break;\
		}\
\
	SendDlgItemMessage (IDC_CB,CB_GETLBTEXT,(WPARAM)i,(LPARAM)s);\
	str = s;\
	delete [] s;\
	break;\
	}

// Load the list box using the CStringArray object
#define LOAD_LB(IDC_LB,strs)\
{\
	SendDlgItemMessage (IDC_LB,LB_RESETCONTENT);\
	long  n = strs.GetSize ();\
	for (long i=0; i<n; i++)\
		{\
		SendDlgItemMessage (IDC_LB,LB_ADDSTRING,0,(LPARAM)(const char *)strs[i]);\
		}\
}

// Load the list box using the PtrSet<STRING> object
#define LOAD_LB_PTRSET(IDC_LB,strs)\
{\
	SendDlgItemMessage (IDC_LB,LB_RESETCONTENT);\
	long  n = strs.GetCount ();\
	for (long i=0; i<n; i++)\
		{\
		STRING *obj = strs.GetObject (i);\
		SendDlgItemMessage (IDC_LB,LB_ADDSTRING,0,(LPARAM)(const char *)*obj);\
		}\
}

// Append the list box using the PtrSet<STRING> object
#define APPEND_LB_PTRSET(IDC_LB,strs)\
{\
	long  n = strs.GetCount ();\
	for (long i=0; i<n; i++)\
		{\
		STRING *obj = strs.GetObject (i);\
		SendDlgItemMessage (IDC_LB,LB_ADDSTRING,0,(LPARAM)(const char *)*obj);\
		}\
}

#define APPEND_LB_CLIPBOARD(IDC_LB)\
	while (1)\
	{\
	PtrSet<STRING> array;\
	if (PasteFromClipboard (&array) == FALSE)\
		break;\
\
	APPEND_LB_PTRSET(IDC_LB,array)\
	break;\
	}

#define SAVE_LB_TO_PROFILE(SECTION,ITEM_NAME,MAX_COUNT,IDC)\
	while (1)\
	{\
	long mx_count = MAX_COUNT;\
	char buffer[1024];\
	char name[1024];\
\
	mx_count = min (MAX_COUNT,1000);\
\
	int n = SendDlgItemMessage (IDC,LB_GETCOUNT);\
	mx_count = min (mx_count,n);\
\
	if (strlen(ITEM_NAME) > 1000)\
		break;\
\
	int i;\
	for (i=0; i<mx_count; i++)\
		{\
		int len = SendDlgItemMessage (IDC,LB_GETTEXTLEN,(WPARAM)i);\
		if (len > 1023)\
			continue;\
\
		if (len <= 0)\
			continue;\
\
		SendDlgItemMessage (IDC,LB_GETTEXT,(WPARAM)i,(LPARAM)buffer);\
\
		sprintf (name,"%s%03ld",ITEM_NAME,i);\
		WritePrivateProfileString (SECTION,name,buffer, g_profile_file);\
		}\
\
	buffer[0] = 0;\
	for (int j=i; j<MAX_COUNT; j++)\
		{\
		sprintf (name,"%s%03ld",ITEM_NAME,j);\
		WritePrivateProfileString (SECTION,name,buffer,g_profile_file);\
		}\
\
	break;\
	}

#define LOAD_LB_FROM_PROFILE(SECTION,ITEM_NAME,MAX_COUNT,IDC)\
{\
	long mx_count = MAX_COUNT;\
\
		while (1)\
			{\
		char buffer[1024];\
		char name[1024];\
\
		SendDlgItemMessage (IDC,LB_RESETCONTENT);\
\
		mx_count = min (mx_count,1000);\
\
		if (strlen(ITEM_NAME) > 1000)\
			break;\
\
		for (int i=0; i<mx_count; i++)\
				{\
			sprintf (name,"%s%03ld",ITEM_NAME,i);\
			if (GetPrivateProfileString (Section,name,"",buffer,1023,g_profile_file))\
				SendDlgItemMessage (IDC,LB_ADDSTRING,0,(LPARAM)buffer);\
				}\
\
		break;\
			}\
}


// Load the list box using the CStringArray object
#define LOAD_CB(IDC_LB,strs)\
{\
	SendDlgItemMessage (IDC_LB,CB_RESETCONTENT);\
	long  n = strs.GetSize ();\
	for (long i=0; i<n; i++)\
		{\
		SendDlgItemMessage (IDC_LB,CB_ADDSTRING,0,(LPARAM)(const char *)strs[i]);\
		}\
}

#define LOAD_CB_PTRSET(IDC_LB,strs)\
{\
	SendDlgItemMessage (IDC_LB,CB_RESETCONTENT);\
	long  n = strs.GetCount ();\
	for (long i=0; i<n; i++)\
		{\
		SendDlgItemMessage (IDC_LB,CB_ADDSTRING,0,(LPARAM)strs.GetIndexedPtr (i)->GetStringConst ());\
		}\
}

#define LOAD_CB_PTRSET_UNSORTED(IDC_LB,strs)\
{\
	SendDlgItemMessage (IDC_LB,CB_RESETCONTENT);\
	long  n = strs.GetCount ();\
	for (long i=0; i<n; i++)\
		{\
		SendDlgItemMessage (IDC_LB,CB_ADDSTRING,0,(LPARAM)strs.GetObject (i)->GetStringConst ());\
		}\
}

#define ON_CB_DROPDOWN(IDC_CB,strs)\
{\
	CString text;\
	GET_TEXT(IDC_CB,text);\
	LOAD_CB(IDC_CB,list);\
\
	if (text.IsEmpty () == FALSE)\
		{\
		int idx = SendDlgItemMessage (IDC_CB,CB_FINDSTRING,0,(LPARAM)(const char *)text);\
		if (idx >= 0)\
			SendDlgItemMessage (IDC_CB,CB_SETCURSEL,(WPARAM)idx);\
		}\
}


#define SAVE_LB(IDC_LB,strs)\
{\
	int n = SendDlgItemMessage (IDC_LB,LB_GETCOUNT);\
	for (int i=0; i<n; i++)\
		{\
		int len = SendDlgItemMessage (IDC_LB,LB_GETTEXTLEN,(WPARAM)i);\
		char *buffer = new char[len+1];\
		if (!buffer)\
			_asm { int 3 };\
		SendDlgItemMessage (IDC_LB,LB_GETTEXT,(WPARAM)i,(LPARAM)buffer);\
		strs.Add (buffer);\
		delete [] buffer;\
		}\
}

#define SAVE_LB_PTRSET(IDC_LB,strs)\
{\
	int n = SendDlgItemMessage (IDC_LB,LB_GETCOUNT);\
	for (int i=0; i<n; i++)\
		{\
		int len = SendDlgItemMessage (IDC_LB,LB_GETTEXTLEN,(WPARAM)i);\
		char *buffer = new char[len+1];\
		if (!buffer)\
			_asm { int 3 };\
		SendDlgItemMessage (IDC_LB,LB_GETTEXT,(WPARAM)i,(LPARAM)buffer);\
		STRING *obj = new STRING (buffer);\
		strs.Append (obj);\
		delete [] buffer;\
		}\
}

#define SAVE_LB_PTRSET_LOWERCASE(IDC_LB,strs)\
{\
	int n = SendDlgItemMessage (IDC_LB,LB_GETCOUNT);\
	for (int i=0; i<n; i++)\
		{\
		int len = SendDlgItemMessage (IDC_LB,LB_GETTEXTLEN,(WPARAM)i);\
		char *buffer = new char[len+1];\
		if (!buffer)\
			_asm { int 3 };\
		SendDlgItemMessage (IDC_LB,LB_GETTEXT,(WPARAM)i,(LPARAM)buffer);\
		STRING *obj = new STRING (buffer);\
		obj->LowerCase ();\
		strs.Append (obj);\
		delete [] buffer;\
		}\
}

#define	REMOVE_SELECTED_LB_STRINGS(IDC_LB)\
	while (1) \
	{\
	int n = SendDlgItemMessage (IDC_LB,LB_GETSELCOUNT);\
\
	if (n < 0)\
		{\
		break;\
		}\
		else\
	if (n == 0)\
		break;\
\
	int *sel_idx = new int[n];\
	if (sel_idx == 0)\
		{\
		break;\
		}\
\
	int nsel = SendDlgItemMessage (IDC_LB,LB_GETSELITEMS,(WPARAM)n,(LPARAM)sel_idx);\
\
	for (int i=nsel-1; i>=0; i--)\
		{\
		if (SendDlgItemMessage (IDC_LB,LB_DELETESTRING,(WPARAM)sel_idx[i]) == LB_ERR)\
			break;\
		}\
\
	delete [] sel_idx;\
\
	break;\
	}


// For multiple selection list boxes, strs is a CStringArray object
#define GET_SELECTED_LB_STRINGS(IDC_LB,strs)\
	while (1) \
	{\
	strs.SetSize(0);\
\
	int n = (int)SendDlgItemMessage (IDC_LB,LB_GETSELCOUNT);\
\
	if (n < 0)\
		{\
		break;\
		}\
		else\
	if (n == 0)\
		break;\
\
	int *sel_idx = new int[n];\
	if (sel_idx == 0)\
		{\
		break;\
		}\
\
	SendDlgItemMessage (IDC_LB,LB_GETSELITEMS,(WPARAM)n,(LPARAM)sel_idx);\
\
	int alloc_sz = 0;\
	char *s = 0;\
\
	for (int i=0; i<n; i++)\
		{\
		int len = (int)SendDlgItemMessage (IDC_LB,LB_GETTEXTLEN,(WPARAM)sel_idx[i]);\
		if (len+1 > alloc_sz)\
				{\
			delete [] s;\
\
			s = new char[len+1];\
\
			if (!s)\
						{\
				break;\
						}\
\
			alloc_sz = len+1;\
				}\
\
		SendDlgItemMessage (IDC_LB,LB_GETTEXT,(WPARAM)sel_idx[i],(LPARAM)s);\
		strs.Add (s);\
		}\
\
	delete [] s;\
	delete [] sel_idx;\
\
	break;\
	}

// For multiple selection list boxes, strs is a CStringArray object
#define GET_LB_STRINGS(IDC_LB,strs)\
	while (1) \
	{\
	strs.SetSize(0);\
\
	int n = SendDlgItemMessage (IDC_LB,LB_GETCOUNT);\
\
	if (n < 0)\
		{\
		break;\
		}\
		else\
	if (n == 0)\
		break;\
\
	int alloc_sz = 0;\
	char *s = 0;\
\
	for (int i=0; i<n; i++)\
		{\
		int len = SendDlgItemMessage (IDC_LB,LB_GETTEXTLEN,(WPARAM)i);\
		if (len+1 > alloc_sz)\
				{\
			delete [] s;\
\
			s = new char[len+1];\
\
			if (!s)\
						{\
				break;\
						}\
\
			alloc_sz = len+1;\
				}\
\
		SendDlgItemMessage (IDC_LB,LB_GETTEXT,(WPARAM)i,(LPARAM)s);\
		strs.Add (s);\
		}\
\
	delete [] s;\
\
	break;\
	}

// For multiple selection list boxes, strs is a PtrSet object
#define GET_SELECTED_LB_STRINGS_PTRSET(IDC_LB,strs)\
	while (1) \
	{\
	strs.RemoveAll ();\
\
	int n = SendDlgItemMessage (IDC_LB,LB_GETSELCOUNT);\
\
	if (n < 0)\
		{\
		break;\
		}\
		else\
	if (n == 0)\
		break;\
\
	int *sel_idx = new int[n];\
	if (sel_idx == 0)\
		{\
		break;\
		}\
\
	SendDlgItemMessage (IDC_LB,LB_GETSELITEMS,(WPARAM)n,(LPARAM)sel_idx);\
\
	int alloc_sz = 0;\
	char *s = 0;\
\
	for (int i=0; i<n; i++)\
		{\
		int len = SendDlgItemMessage (IDC_LB,LB_GETTEXTLEN,(WPARAM)sel_idx[i]);\
		if (len+1 > alloc_sz)\
				{\
			delete [] s;\
\
			s = new char[len+1];\
\
			if (!s)\
						{\
				break;\
						}\
\
			alloc_sz = len+1;\
				}\
\
		SendDlgItemMessage (IDC_LB,LB_GETTEXT,(WPARAM)sel_idx[i],(LPARAM)s);\
		STRING *obj = new STRING (s);\
		strs.Append (obj);\
		}\
\
	delete [] s;\
	delete [] sel_idx;\
\
	break;\
	}

// For multiple selection list boxes, strs is a PtrSet object
// also get an array of data objects, data must be WorkbenchLib::DWORD_Array
#define GET_SELECTED_LB_STRINGS_PTRSET_EX(IDC_LB,strs,data)\
	while (1) \
	{\
	strs.RemoveAll ();\
	data.SetSize (0);\
\
	int n = SendDlgItemMessage (IDC_LB,LB_GETSELCOUNT);\
\
	if (n < 0)\
		{\
		break;\
		}\
		else\
	if (n == 0)\
		break;\
\
	int *sel_idx = new int[n];\
	if (sel_idx == 0)\
		{\
		break;\
		}\
\
	SendDlgItemMessage (IDC_LB,LB_GETSELITEMS,(WPARAM)n,(LPARAM)sel_idx);\
\
	int alloc_sz = 0;\
	char *s = 0;\
\
	for (int i=0; i<n; i++)\
		{\
		int len = SendDlgItemMessage (IDC_LB,LB_GETTEXTLEN,(WPARAM)sel_idx[i]);\
		if (len+1 > alloc_sz)\
				{\
			delete [] s;\
\
			s = new char[len+1];\
\
			if (!s)\
						{\
				break;\
						}\
\
			alloc_sz = len+1;\
				}\
\
		SendDlgItemMessage (IDC_LB,LB_GETTEXT,(WPARAM)sel_idx[i],(LPARAM)s);\
		STRING *obj = new STRING (s);\
		strs.Append (obj);\
		DWORD u4 = SendDlgItemMessage(IDC_LB,LB_GETITEMDATA,(WPARAM)sel_idx[i]);\
		data.Append (u4);\
		}\
\
	delete [] s;\
	delete [] sel_idx;\
\
	break;\
	}


#define _LOAD_FROM_PROFILE(FILE,SECTION,ITEM,IDC) \
		{\
		char s[1024];\
		GetPrivateProfileString (SECTION,ITEM,"",s,1023,FILE);\
		SET_TEXT(IDC,s)\
		}

inline bool LOAD_FROM_PROFILE_h(HWND h, const char *SECTION, const char *ITEM, UINT IDC, const char *FILE)
{
	char s[1024]; 
	BOOL status = GetPrivateProfileString(SECTION, ITEM, "", s, 1023, FILE); 
	SET_TEXT_h(h, IDC, s);
	return status ? true : false;
}

#define LOAD_FROM_PROFILE(SECTION,ITEM,IDC) \
		{\
		char s[1024];\
		GetPrivateProfileString (SECTION,ITEM,"",s,1023,g_profile_file);\
		SET_TEXT(IDC,s)\
		}

#define LOAD_FROM_PROFILE_EX(SECTION,ITEM,IDC,DEFAULT) \
		{\
		char s[1024];\
		GetPrivateProfileString (SECTION,ITEM,DEFAULT,s,1023,g_profile_file);\
		SET_TEXT(IDC,s)\
		}

#define LOAD_FROM_PROFILE_EX_t(SECTION,ITEM,IDC,DEFAULT,PROFILE_FILE) \
		{\
		char s[1024];\
		GetPrivateProfileString (SECTION,ITEM,DEFAULT,s,1023,PROFILE_FILE);\
		SET_TEXT(IDC,s)\
		}

#ifdef _MFC_VER
inline void _LOAD_FROM_PROFILE_EX(const char *SECTION, const char *ITEM, UINT IDC, const char *DEFAULT, CWnd *dlg, const char *profile_file)
{
	char __s__[1024]; \
		DWORD nchar = GetPrivateProfileString(SECTION, ITEM, DEFAULT, __s__, 1023, profile_file);
	_SET_TEXT(IDC, __s__, dlg);
}
#endif

#define SAVE_TO_PROFILE(SECTION,ITEM,IDC)\
	{\
		CString __s__;\
		GET_TEXT(IDC,__s__)\
		WritePrivateProfileString (SECTION,ITEM,__s__,g_profile_file);\
	}


inline bool SAVE_TO_PROFILE_h(HWND h, const char *SECTION, const char *ITEM, UINT IDC, const char *FILE)
{
	STRING s;
	GET_TEXT_h(h, IDC, s);
	BOOL status = WritePrivateProfileString (SECTION,ITEM,s,FILE);
	return status ? true : false;
}


#define SAVE_TO_PROFILE_t(SECTION,ITEM,IDC,PROFILE_FILE)\
	{\
		CString __s__;\
		GET_TEXT(IDC,__s__)\
		WritePrivateProfileString (SECTION,ITEM,__s__,PROFILE_FILE);\
	}

#ifdef _MFC_VER
inline void _SAVE_TO_PROFILE(const char *SECTION, const char *ITEM, UINT IDC, CWnd *dlg, const char *profile_file)
{
	CString s;
	_GET_TEXT(IDC, s, dlg);
	DWORD nchar = WritePrivateProfileString(SECTION, ITEM, s, profile_file);
}
#endif

inline bool SAVE_CHECK_STATE_TO_PROFILE_h(HWND h, const char *SECTION, const char *ITEM, UINT IDC, const char *FILE)
{
	BOOL status;
	if (IsDlgButtonChecked(h, IDC) == TRUE)
	{
		status = WritePrivateProfileString(SECTION, ITEM, "TRUE", FILE);
	}
	else
	{
		status = WritePrivateProfileString(SECTION, ITEM, "FALSE", FILE);
	}

	return status ? true : false;
}

#define SAVE_CHECK_STATE_TO_PROFILE(SECTION,ITEM,IDC)\
	if (IsDlgButtonChecked (IDC) == TRUE)\
				{\
		WritePrivateProfileString (SECTION,ITEM,"TRUE",g_profile_file);\
				}\
								else\
	{\
		WritePrivateProfileString (SECTION,ITEM,"FALSE",g_profile_file);\
	}

#define SAVE_CHECK_STATE_TO_PROFILE_t(SECTION,ITEM,IDC,PROFILE_FILE)\
	if (IsDlgButtonChecked (IDC) == TRUE)\
			{\
		WritePrivateProfileString (SECTION,ITEM,"TRUE",PROFILE_FILE);\
			}\
				else\
	{\
		WritePrivateProfileString (SECTION,ITEM,"FALSE",PROFILE_FILE);\
	}

#define LOAD_CHECK_STATE_FROM_PROFILE_VAR_BOOL(SECTION,ITEM,bState)\
{\
	char s[10];\
	GetPrivateProfileString (SECTION,ITEM,"",s,9,g_profile_file);\
	if (IsEqualTo (s,"TRUE") == TRUE)\
		{\
		bState=TRUE;\
		}\
		else if (IsEqualTo (s,"FALSE") == TRUE)\
	{\
		bState=FALSE;\
	}\
		else\
		bState=FALSE;\
}


#define LOAD_CHECK_STATE_FROM_PROFILE_VAR_BOOL_t(SECTION,ITEM,bState,bStateDef,PROFILE_FILE)\
{\
	char s[10];\
	GetPrivateProfileString (SECTION,ITEM,"",s,9,PROFILE_FILE);\
	if (IsEqualTo (s,"TRUE") == TRUE) { bState=TRUE;	}\
	else if (IsEqualTo (s,"FALSE") == TRUE) { bState=FALSE; }\
				else\
		bState=bStateDef;\
}

#define SAVE_CHECK_STATE_TO_PROFILE_VAR_BOOL(SECTION,ITEM,bState)\
{\
	if (bState == TRUE)\
			{\
		WritePrivateProfileString (SECTION,ITEM,"TRUE",g_profile_file);\
			}\
				else\
	{\
		WritePrivateProfileString (SECTION,ITEM,"FALSE",g_profile_file);\
	}\
}

#define SAVE_CHECK_STATE_TO_PROFILE_VAR_BOOL_t(SECTION,ITEM,bState,PROFILE_FILE)\
{\
	if (bState == TRUE)\
			{\
		WritePrivateProfileString (SECTION,ITEM,"TRUE",PROFILE_FILE);\
			}\
				else\
	{\
		WritePrivateProfileString (SECTION,ITEM,"FALSE",PROFILE_FILE);\
	}\
}

inline bool LOAD_CHECK_STATE_FROM_PROFILE_h(HWND h, const char *SECTION, const char *ITEM, UINT IDC, const char *FILE)
{
	char s[10];
	GetPrivateProfileString (SECTION,ITEM,"",s,9,FILE);
	if (IsEqualTo (s,"TRUE") == TRUE)
	{
		CheckDlgButton (h, IDC,TRUE);
		return true;
	}

	if (IsEqualTo (s,"FALSE") == TRUE)
	{
		CheckDlgButton (h, IDC,FALSE);
		return true;
	}

	return false;
}

#define LOAD_CHECK_STATE_FROM_PROFILE(SECTION,ITEM,IDC)\
{\
	char s[10];\
	GetPrivateProfileString (SECTION,ITEM,"",s,9,g_profile_file);\
	if (IsEqualTo (s,"TRUE") == TRUE)\
			{\
		CheckDlgButton (IDC,TRUE);\
			}\
				else if (IsEqualTo (s,"FALSE") == TRUE)\
	{\
		CheckDlgButton (IDC,FALSE);\
	}\
}


#define LOAD_CHECK_STATE_FROM_PROFILE_EX(SECTION,ITEM,IDC,DEF_STATE)\
{\
	char s[10];\
	GetPrivateProfileString (SECTION,ITEM,"",s,9,g_profile_file);\
	if (IsEqualTo (s,"TRUE") == TRUE)\
		{\
		CheckDlgButton (IDC,TRUE);\
		}\
		else if (IsEqualTo (s,"FALSE") == TRUE)\
	{\
		CheckDlgButton (IDC,FALSE);\
	}\
		else\
	{\
		if (DEF_STATE)\
			CheckDlgButton (IDC,TRUE);\
				else\
			CheckDlgButton (IDC,FALSE);\
	}\
}


#define LOAD_CHECK_STATE_FROM_PROFILE_EX_t(SECTION,ITEM,IDC,DEF_STATE,PROFILE_FILE)\
{\
	char s[10];\
	GetPrivateProfileString (SECTION,ITEM,"",s,9,PROFILE_FILE);\
	if (IsEqualTo (s,"TRUE") == TRUE)\
			{\
		CheckDlgButton (IDC,TRUE);\
			}\
				else if (IsEqualTo (s,"FALSE") == TRUE)\
	{\
		CheckDlgButton (IDC,FALSE);\
	}\
				else\
	{\
		if (DEF_STATE)\
			CheckDlgButton (IDC,TRUE);\
								else\
			CheckDlgButton (IDC,FALSE);\
	}\
}


#define LOAD_FROM_PROFILE_VAR_double(SECTION,ITEM,F,F_DEF)\
{\
	char s[32];\
	GetPrivateProfileString (SECTION,ITEM,"",s,31,g_profile_file);\
	if (sscanf_s (s,"%lf",&F) != 1)\
			{\
		F = F_DEF;\
			}\
}

#define LOAD_FROM_PROFILE_VAR_double_t(SECTION,ITEM,F,F_DEF,PROFILE_FILE)\
{\
	char s[32];\
	GetPrivateProfileString (SECTION,ITEM,"",s,31,PROFILE_FILE);\
	if (sscanf_s (s,"%lf",&F) != 1)\
			{\
		F = F_DEF;\
			}\
}

#define LOAD_FROM_PROFILE_VAR_float(SECTION,ITEM,F,F_DEF)\
{\
	char s[32];\
	GetPrivateProfileString (SECTION,ITEM,"",s,31,g_profile_file);\
	if (sscanf (s,"%f",&F) != 1)\
			{\
		F = F_DEF;\
			}\
}

#define LOAD_FROM_PROFILE_VAR_float_t(SECTION,ITEM,F,F_DEF,PROFILE_FILE)\
{\
	char s[32];\
	GetPrivateProfileString (SECTION,ITEM,"",s,31,(const char *)PROFILE_FILE);\
	if (sscanf (s,"%f",&F) != 1) F = F_DEF;\
}

#define LOAD_FROM_PROFILE_VAR_WORD(SECTION,ITEM,U2,U2_DEF)\
{\
	char s[32];\
	GetPrivateProfileString (SECTION,ITEM,"",s,31,g_profile_file);\
	DWORD u4;\
	if (sscanf_s (s,"%ul",&u4) != 1)\
		{\
		U2 = U2_DEF;\
		}\
	U2 = (WORD) u4;\
}

#define LOAD_FROM_PROFILE_VAR_int(SECTION,ITEM,I,I_DEF)\
{\
	char s[32];\
	GetPrivateProfileString (SECTION,ITEM,"",s,31,g_profile_file);\
if (sscanf_s(s, "%" SCNd32 "", &I) != 1)\
	{\
		I = I_DEF;\
	}\
}

#define LOAD_FROM_PROFILE_VAR_int_t(SECTION,ITEM,I,I_DEF,PROFILE_FILE)\
{\
	char s[32];\
	GetPrivateProfileString (SECTION,ITEM,"",s,31,PROFILE_FILE);\
if (sscanf_s(s, "%" SCNd32 "", &I) != 1)\
	{\
		I = I_DEF;\
	}\
}

#define LOAD_FROM_PROFILE_VAR_STRING(SECTION,ITEM,S,S_DEF)\
{\
	char s[1024];\
	GetPrivateProfileString (SECTION,ITEM,S_DEF,s,1023,g_profile_file);\
	S = s;\
}

#define _LOAD_FROM_PROFILE_VAR_STRING(FILE, SECTION,ITEM,S,S_DEF)\
{\
	char s[1024];\
	GetPrivateProfileString (SECTION,ITEM,S_DEF,s,1023,FILE);\
	S = s;\
}

#define SAVE_TO_PROFILE_VAR_double(SECTION,ITEM,F)\
{\
	STRING snum = (double) F;\
	WritePrivateProfileString (SECTION,ITEM,(const char *)snum,g_profile_file);\
}

#define SAVE_TO_PROFILE_VAR_float(SECTION,ITEM,F)\
{\
	STRING snum = (float) F;\
	WritePrivateProfileString (SECTION,ITEM,(const char *)snum,g_profile_file);\
}

#define SAVE_TO_PROFILE_VAR_float_t(SECTION,ITEM,F,PROFILE_FILE)\
{\
	STRING snum = (float) F;\
	WritePrivateProfileString (SECTION,ITEM,(const char *)snum,PROFILE_FILE);\
}

#define SAVE_TO_PROFILE_VAR_WORD(SECTION,ITEM,U2)\
{\
	STRING snum = (WORD) U2;\
	WritePrivateProfileString (SECTION,ITEM,(const char *)snum,g_profile_file);\
}

#define SAVE_TO_PROFILE_VAR_int(SECTION,ITEM,I)\
{\
	STRING snum = (long) I;\
	WritePrivateProfileString (SECTION,ITEM,(const char *)snum,g_profile_file);\
}

#define SAVE_TO_PROFILE_VAR_int_t(SECTION,ITEM,I,PROFILE_FILE)\
{\
	STRING snum = (long) I;\
	WritePrivateProfileString (SECTION,ITEM,(const char *)snum,PROFILE_FILE);\
}

#define SAVE_TO_PROFILE_VAR(SECTION,ITEM,__S__)\
	WritePrivateProfileString (SECTION,ITEM,(const char *)__S__,g_profile_file);

#define _SAVE_TO_PROFILE_VAR(FILE,SECTION,ITEM,__S__)\
	WritePrivateProfileString (SECTION,ITEM,(const char *)__S__,FILE);

#define LOAD_FROM_PROFILE_VAR_BOOL_EX(SECTION,ITEM,b,default_value)\
{\
	char s[10];\
	GetPrivateProfileString (SECTION,ITEM,"",s,9,g_profile_file);\
	if (IsEqualTo (s,"TRUE") == TRUE)\
			{\
		b = TRUE;\
			}\
				else if (IsEqualTo (s,"FALSE") == TRUE)\
		{\
		b = FALSE;\
		}\
				else\
		{\
		b = default_value;\
		}\
}

#define LOAD_FROM_PROFILE_VAR_BOOL_EX_t(SECTION,ITEM,b,default_value,PROFILE_FILE)\
{\
	char s[10];\
	GetPrivateProfileString (SECTION,ITEM,"",s,9,PROFILE_FILE);\
	if (IsEqualTo (s,"TRUE") == TRUE)\
			{\
		b = TRUE;\
			}\
				else if (IsEqualTo (s,"FALSE") == TRUE)\
		{\
		b = FALSE;\
		}\
				else\
		{\
		b = default_value;\
		}\
}

#define LOAD_FROM_PROFILE_VAR(SECTION,ITEM,str)\
{\
	char __s_tmp__[1024];\
	GetPrivateProfileString (SECTION,ITEM,"",__s_tmp__,1023,g_profile_file);\
	str = __s_tmp__;\
}

#define LOAD_FROM_PROFILE_VAR_BOOL(SECTION,ITEM,b)\
{\
	char s[10];\
	GetPrivateProfileString (SECTION,ITEM,"",s,9,g_profile_file);\
	if (IsEqualTo (s,"TRUE") == TRUE)\
		{\
		b = TRUE;\
		}\
		else if (IsEqualTo (s,"FALSE") == TRUE)\
	{\
		b = FALSE;\
	}\
}

#define SAVE_TO_PROFILE_VAR_BOOL(SECTION,ITEM,b)\
	if (b == TRUE)\
		{\
		WritePrivateProfileString (SECTION,ITEM,"TRUE",g_profile_file);\
		}\
		else\
	{\
		WritePrivateProfileString (SECTION,ITEM,"FALSE",g_profile_file);\
	}

#define IS_CHECKED(IDC) ( (GetDlgItem(IDC) && IsDlgButtonChecked (IDC) == TRUE) ? TRUE : FALSE)		
#define IS_ENABLED(IDC) ( (GetDlgItem(IDC) && GetDlgItem(IDC)->IsWindowEnabled () == TRUE) ? TRUE : FALSE)		

#define HIDE_IDC(IDC)\
{\
	CWnd *wnd = GetDlgItem (IDC);\
	if (wnd && IsWindow (wnd->m_hWnd))\
		{\
		wnd->ShowWindow (SW_HIDE);\
		}\
}

#define SHOW_IDC(IDC)\
{\
	CWnd *wnd = GetDlgItem (IDC);\
	if (wnd && IsWindow (wnd->m_hWnd))\
		{\
		wnd->ShowWindow (SW_SHOW);\
		}\
}


#define GET_BOTTOM(IDC,bottom)\
{\
	CWnd *wnd = 0;\
	wnd = GetDlgItem (IDC);\
\
	if (wnd && IsWindow (wnd->m_hWnd))\
		{\
		WINDOWPLACEMENT wp;\
		if (wnd->GetWindowPlacement (&wp))\
				{\
			bottom = wp.rcNormalPosition.bottom;\
				}\
		}\
}

#define SET_BOTTOM(IDC,bottom)\
{\
	CWnd *wnd = 0;\
	wnd = GetDlgItem (IDC);\
\
	if (wnd && IsWindow (wnd->m_hWnd))\
		{\
		WINDOWPLACEMENT wp;\
		if (wnd->GetWindowPlacement (&wp))\
				{\
			wp.rcNormalPosition.bottom = bottom;\
			wnd->SetWindowPlacement (&wp);\
				}\
		}\
}


// For multiple selection list boxes, strs is a CStringArray object
#define MOVE_SELECTED_LB_STRINGS(IDC_LB_SOURCE,IDC_LB_TARGET)\
	while (1) \
	{\
	CStringArray strs;\
\
	int n = SendDlgItemMessage (IDC_LB_SOURCE,LB_GETSELCOUNT);\
\
	if (n < 0)\
		{\
		break;\
		}\
		else\
	if (n == 0)\
		break;\
\
	int *sel_idx = new int[n];\
	if (sel_idx == 0)\
		{\
		break;\
		}\
\
	SendDlgItemMessage (IDC_LB_SOURCE,LB_GETSELITEMS,(WPARAM)n,(LPARAM)sel_idx);\
\
	int alloc_sz = 0;\
	char *s = 0;\
\
	int i;\
	for (i=0; i<n; i++)\
		{\
		int len = SendDlgItemMessage (IDC_LB_SOURCE,LB_GETTEXTLEN,(WPARAM)sel_idx[i]);\
		if (len+1 > alloc_sz)\
				{\
			delete [] s;\
\
			s = new char[len+1];\
\
			if (!s)\
						{\
				break;\
						}\
\
			alloc_sz = len+1;\
				}\
\
		SendDlgItemMessage (IDC_LB_SOURCE,LB_GETTEXT,(WPARAM)sel_idx[i],(LPARAM)s);\
		strs.Add (s);\
		}\
\
	for (i=n-1;i>=0;i--)\
		{\
		SendDlgItemMessage (IDC_LB_SOURCE,LB_DELETESTRING,(WPARAM)sel_idx[i]);\
		}\
\
	for (i=0; i<n; i++)\
		{\
		SendDlgItemMessage (IDC_LB_TARGET,LB_ADDSTRING,NULL,(LPARAM)(const char *)strs[i]);\
		}\
\
	delete [] s;\
	delete [] sel_idx;\
\
	break;\
	}

#define IS_VISIBLE(IDC) (GetDlgItem(IDC) == 0 ? FALSE : GetDlgItem(IDC)->IsWindowVisible ())

inline void ClientToScreen(HWND h, RECT *rect)
{
	POINT UL, LR;
	UL.x = rect->left;
	UL.y = rect->top;
	ClientToScreen(h, &UL);
	LR.x = rect->right;
	LR.y = rect->bottom;
	ClientToScreen(h, &LR);

	rect->left = UL.x;
	rect->top = UL.y;
	rect->right = LR.x;
	rect->bottom = LR.y;
}

inline void CONFORM_RIGHT_SIDE_h(HWND hDlg, UINT IDC, int OFFSET, int MIN_WIDTH)
{
	RECT rect;
	GetClientRect (hDlg, &rect);
	ClientToScreen(hDlg, &rect);

	HWND h = GetDlgItem (hDlg,IDC);	
	if (IsWindow (h) && IsWindowVisible(h))\
	{
		RECT rect_images;\
		GetClientRect (h, &rect_images);
		ClientToScreen (h, &rect_images);
	
		while (1)
		{
			if (rect_images.right < rect.right - OFFSET)
			{
				rect_images.right = rect.right - OFFSET;
				break;
			}
			else
			{
				rect_images.right = rect.right - OFFSET;
				rect_images.right = max (rect_images.right,rect_images.left + MIN_WIDTH - 1);
				break;
			}
		}

		WINDOWPLACEMENT wp;
		GetWindowPlacement (h, &wp);
		wp.rcNormalPosition.right = wp.rcNormalPosition.left + (rect_images.right-rect_images.left+1);
		SetWindowPlacement (h, &wp);
	}
}

#define CONFORM_RIGHT_SIDE(IDC, OFFSET, MIN_WIDTH) CONFORM_RIGHT_SIDE_h(m_hWnd, IDC, OFFSET, MIN_WIDTH)

#define CONFORM_BOTTOM_SIDE(IDC,OFFSET,MIN_HEIGHT)\
{\
	RECT rect;\
	GetClientRect (&rect);\
	ClientToScreen (&rect);\
\
	CWnd *wnd = GetDlgItem (IDC);	\
	if (wnd && IsWindow (wnd->m_hWnd) && wnd->IsWindowVisible())\
		{\
		RECT rect_images;\
		wnd->GetClientRect (&rect_images);\
		wnd->ClientToScreen (&rect_images);\
		\
				while (1)\
						{\
			if (rect_images.bottom < rect.bottom - OFFSET)\
						{\
				rect_images.bottom = rect.bottom - OFFSET;\
				break;\
						}\
						else\
			{\
				rect_images.bottom = rect.bottom - OFFSET;\
				rect_images.bottom = max (rect_images.bottom,rect_images.top + MIN_HEIGHT - 1);\
				break;\
			}\
						}\
\
		WINDOWPLACEMENT wp;\
		wnd->GetWindowPlacement (&wp);\
		wp.rcNormalPosition.bottom = wp.rcNormalPosition.top + (rect_images.bottom-rect_images.top+1);\
		wnd->SetWindowPlacement (&wp);\
		}\
}

#ifdef _MFC_VER
inline BOOL SET_PROFILE_LONG(const char *FILE, const char *SECTION, const char *ITEM, long VALUE, CString &ERR_MSG)
{
	char s[256];

	int len = sprintf_s(s, sizeof(s), "%" SCNd32 "", VALUE);

	if (WritePrivateProfileString(SECTION, ITEM, s, FILE) == FALSE)
	{
		ERR_MSG = "Problem writing value: ";
		ERR_MSG += (const char *)ITEM;
		ERR_MSG += " from section: ";
		ERR_MSG += (const char *)SECTION;
		ERR_MSG += " in file: ";
		ERR_MSG += (const char *)FILE;
		return FALSE;
	}

	return TRUE;
}

inline BOOL GET_PROFILE_LONG(const char *FILE, const char *SECTION, const char *ITEM, long &VALUE, CString &ERR_MSG)
{
	char s[256];

	if (GetPrivateProfileString(SECTION, ITEM, "", s, 255, FILE) == 0)
	{
		ERR_MSG = "Problem extracting value: ";
		ERR_MSG += (const char *)ITEM;
		ERR_MSG += " from section: ";
		ERR_MSG += (const char *)SECTION;
		ERR_MSG += " in file: ";
		ERR_MSG += (const char *)FILE;
		return FALSE;
	}

	if (sscanf_s(s, "%" SCNd32 "", &VALUE) != 1)
	{
		ERR_MSG = "Invalid string for value: ";
		ERR_MSG += (const char *)ITEM;
		ERR_MSG += " from section: ";
		ERR_MSG += (const char *)SECTION;
		ERR_MSG += " in file: ";
		ERR_MSG += (const char *)FILE;
		return FALSE;
	}

	return TRUE;
}

inline BOOL GET_PROFILE_DOUBLE(const char *FILE, const char *SECTION, const char *ITEM, double &VALUE, CString &ERR_MSG)
{
	char s[256];

	if (GetPrivateProfileString(SECTION, ITEM, "", s, 255, FILE) == 0)
	{
		ERR_MSG = "Problem extracting value: ";
		ERR_MSG += (const char *)ITEM;
		ERR_MSG += " from section: ";
		ERR_MSG += (const char *)SECTION;
		ERR_MSG += " in file: ";
		ERR_MSG += (const char *)FILE;
		return FALSE;
	}

	if (sscanf_s(s, "%lf", &VALUE) != 1)
	{
		ERR_MSG = "Invalid string for value: ";
		ERR_MSG += (const char *)ITEM;
		ERR_MSG += " from section: ";
		ERR_MSG += (const char *)SECTION;
		ERR_MSG += " in file: ";
		ERR_MSG += (const char *)FILE;
		return FALSE;
	}

	return TRUE;
}

inline BOOL GET_PROFILE(const char *FILE, const char *SECTION, const char *ITEM, STRING &value)
{
	char s[2048];

	if (GetPrivateProfileString(SECTION, ITEM, "", s, 2047, FILE) == 0)
		return FALSE;

	value = s;
	return TRUE;
}

class CColorButton : public CButton
{
public:
	inline CColorButton(void)
	{
		m_text_color = RGB(0, 0, 0);
		m_color = RGB(192, 192, 192);
	}

	inline ~CColorButton(void) {}

	inline void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
	{
		CDC dc;
		dc.Attach(lpDrawItemStruct->hDC);     //Get device context object
		CRect rt;
		rt = lpDrawItemStruct->rcItem;        //Get button rect

		dc.FillSolidRect(rt, m_color); //Fill button with the color

		UINT state = lpDrawItemStruct->itemState; //Get state of the button
		if ((state & ODS_SELECTED))            // If it is pressed
			dc.DrawEdge(rt, EDGE_SUNKEN, BF_RECT);    // Draw a sunken face
		else
			dc.DrawEdge(rt, EDGE_RAISED, BF_RECT);    // Draw a raised face

		dc.SetTextColor(m_text_color);

		// Set the color of the caption to be yellow
		CString text;
		GetWindowText(text);

		if (text.IsEmpty() == FALSE)
		{
			// Get the caption which have been set
			dc.DrawText(text, rt, DT_CENTER | DT_VCENTER | DT_SINGLELINE);
		}
		// Draw out the caption
		if ((state & ODS_FOCUS))       // If the button is focused
		{
			// Draw a focus rect which indicates the user 
			// that the button is focused
			int iChange = 3;
			rt.top += iChange;
			rt.left += iChange;
			rt.right -= iChange;
			rt.bottom -= iChange;
			dc.DrawFocusRect(rt);
		}

		dc.Detach();
	}

	COLORREF m_color, m_text_color;
};

#endif

#define IGNORE_CR\
	if (pMsg->message == WM_CHAR || pMsg->message == WM_KEYDOWN)\
		{\
		if (pMsg->hwnd == m_hWnd)\
				{\
			if (pMsg->wParam == 0x0D)\
				return TRUE;\
				}\
		}

#define IGNORE_ESC\
	if (pMsg->message == WM_CHAR || pMsg->message == WM_KEYDOWN)\
		{\
		if (pMsg->hwnd == m_hWnd)\
				{\
			if (pMsg->wParam == 0x1B)\
				return TRUE;\
				}\
		}

#define SELECT_ALL(IDC)\
{\
	int n = SendDlgItemMessage (IDC,LB_GETCOUNT);\
	if (n >= 0)\
		{\
		SendDlgItemMessage (IDC, LB_SELITEMRANGE, (WPARAM)TRUE, MAKELPARAM(0,n-1)); \
		}\
}

#define LOAD_FT_FROM_PROFILE(SECTION,ITEM,MEMBER)\
{\
	FILETIME ft;\
	char buffer[32];\
	int len = GetPrivateProfileString (SECTION,ITEM,"",buffer,31,g_profile_file);\
	BOOL success = FALSE;\
		while (len >= 16)\
			{\
\
		if (get_DWORD_hex (buffer,(DWORD &)ft.dwHighDateTime) == FALSE)\
			break;\
\
		if (get_DWORD_hex (buffer+8,(DWORD &)ft.dwLowDateTime) == FALSE)\
			break;\
\
		success = TRUE;\
		break;\
			}\
\
	if (success == FALSE)\
		{\
		SYSTEMTIME st;\
		GetSystemTime (&st);\
		SystemTimeToFileTime (&st,&ft);\
		}\
\
	MEMBER = ft;\
	UpdateData (FALSE);\
}

#define SAVE_FT_TO_PROFILE(SECTION,ITEM,MEMBER)\
{\
	UpdateData(TRUE);\
	SYSTEMTIME st;\
	MEMBER.GetAsSystemTime (st);\
	FILETIME ft;\
	SystemTimeToFileTime (&st,&ft);\
	STRING s;\
	s.AppendFILETIME (ft);\
	WritePrivateProfileString (SECTION,ITEM,(const char *)s,g_profile_file);\
}

#define VISIBLE(IDC)\
{\
	CWnd *wnd = GetDlgItem(IDC);\
	if (wnd)\
		wnd->ShowWindow (SW_SHOW);\
}

#define INVISIBLE(IDC)\
{\
	CWnd *wnd = GetDlgItem(IDC);\
	if (wnd)\
		wnd->ShowWindow (SW_HIDE);\
}

inline void BROWSE_FOR_FILE_h(HWND hDlg, UINT IDC, const char *title = 0)
{
	STRING path, s, ext;

	GET_TEXT_h(hDlg, IDC, s);

	STRING fname;
	fname.LoadFileName(s, FALSE, TRUE, TRUE);

	path.LoadFileName(s, TRUE, FALSE, FALSE);
	ext.LoadFileName(s, FALSE, FALSE, TRUE);
	ext.Insert(0, "*");

	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof(ofn));

	ofn.lStructSize = sizeof(ofn);
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrTitle = title;
	ofn.hwndOwner = hDlg;

	char s_file_name[2048];
	int len = StrLen(s);
	if (len > sizeof(s_file_name))
		len = sizeof(s_file_name);

	memmove(s_file_name, (const char *)fname, len);
	s_file_name[len] = 0;
	ofn.lpstrFile = s_file_name;
	ofn.nMaxFile = sizeof(s_file_name);

	ofn.lpstrInitialDir = (const char *)path;

	BOOL status = GetOpenFileName(&ofn);

	if (status == TRUE)
		SET_TEXT_h(hDlg, IDC, s_file_name);
}

inline void BROWSE_FOR_NEW_FILE_h(HWND hDlg, UINT IDC, const char *title = 0)
{
	STRING path, s, ext;

	GET_TEXT_h(hDlg, IDC, s);

	STRING fname;
	fname.LoadFileName(s, FALSE, TRUE, TRUE);

	path.LoadFileName(s, TRUE, FALSE, FALSE);
	ext.LoadFileName(s, FALSE, FALSE, TRUE);
	ext.Insert(0, "*");

	OPENFILENAME ofn;
	ZeroMemory(&ofn, sizeof(ofn));

	ofn.lStructSize = sizeof(ofn);
	ofn.Flags = OFN_HIDEREADONLY;
	ofn.lpstrTitle = title;
	ofn.hwndOwner = hDlg;

	char s_file_name[2048];
	int len = StrLen(s);
	if (len > sizeof(s_file_name))
		len = sizeof(s_file_name);

	memmove(s_file_name, (const char *)fname, len);
	s_file_name[len] = 0;
	ofn.lpstrFile = s_file_name;
	ofn.nMaxFile = sizeof(s_file_name);

	ofn.lpstrInitialDir = (const char *)path;

	BOOL status = GetOpenFileName(&ofn);

	if (status == TRUE)
		SET_TEXT_h(hDlg, IDC, s_file_name);
}


#define BROWSE_FOR_FILE(IDC,TITLE)\
{\
	STRING path,s,file_name,ext;\
\
	GET_TEXT(IDC,s)\
	path.LoadFileName (s,TRUE,FALSE,FALSE);\
	ext.LoadFileName (s,FALSE,FALSE,TRUE);\
	ext.Insert (0,"*");\
\
    CFileSpecSelection file_sel;\
\
    STRING extension;\
\
    file_sel.SetTitleString (TITLE);\
    file_sel.HideReadOnly (TRUE);\
    file_sel.FileMustExist (TRUE);\
	file_sel.PromptIfFileExists (FALSE);\
	file_sel.PromptIfFileDoesNotExist (FALSE);\
	file_sel.SetFileName (ext);\
\
	file_sel.SetStartPath (path);\
\
    if (file_sel.Select () == TRUE)\
		{\
		file_sel.GetFileName (file_name);\
		SET_TEXT(IDC,file_name)\
		}\
}


#define BROWSE_FOR_NEW_FILE(IDC,TITLE)\
{\
	STRING path,s,file_name,ext;\
\
	GET_TEXT(IDC,s)\
	path.LoadFileName (s,TRUE,FALSE,FALSE);\
	ext.LoadFileName (s,FALSE,FALSE,TRUE);\
	ext.Insert (0,"*");\
\
    CFileSpecSelection file_sel;\
\
    STRING extension;\
\
    file_sel.SetTitleString (TITLE);\
    file_sel.HideReadOnly (TRUE);\
    file_sel.FileMustExist (FALSE);\
	file_sel.PromptIfFileExists (FALSE);\
	file_sel.PromptIfFileDoesNotExist (FALSE);\
	file_sel.SetFileName (ext);\
\
	file_sel.SetStartPath (path);\
\
    if (file_sel.Select () == TRUE)\
			{\
		file_sel.GetFileName (file_name);\
		SET_TEXT(IDC,file_name)\
			}\
}

#define BROWSE_FOR_FILE_NEW(IDC,TITLE)\
{\
	STRING path,s,file_name,ext;\
\
	GET_TEXT(IDC,s)\
	path.LoadFileName (s,TRUE,FALSE,FALSE);\
	ext.LoadFileName (s,FALSE,FALSE,TRUE);\
	ext.Insert (0,"*");\
\
    CFileSpecSelection file_sel;\
\
    STRING extension;\
\
    file_sel.SetTitleString (TITLE);\
    file_sel.HideReadOnly (TRUE);\
    file_sel.FileMustExist (TRUE);\
	file_sel.PromptIfFileExists (FALSE);\
	file_sel.PromptIfFileDoesNotExist (TRUE);\
	file_sel.SetFileName (ext);\
\
	file_sel.SetStartPath (path);\
\
    if (file_sel.Select () == TRUE)\
		{\
		file_sel.GetFileName (file_name);\
		SET_TEXT(IDC,file_name)\
		}\
}

#define HIDE_SCROLL_BARS \
{\
	ModifyStyle (WS_HSCROLL|WS_VSCROLL,0,SWP_NOZORDER);\
	WINDOWPLACEMENT wp;\
	if (GetWindowPlacement (&wp) == TRUE)\
		{\
		wp.rcNormalPosition.left++;\
		if (SetWindowPlacement (&wp))\
				{\
			wp.rcNormalPosition.left--; \
			SetWindowPlacement (&wp);\
				}\
		}\
}

#define SHOW_SCROLL_BARS(V,H) \
{\
	DWORD style = 0;\
	if (V) style |= WS_VSCROLL;\
	if (H) style |= WS_HSCROLL;\
	ModifyStyle (0,style);\
	WINDOWPLACEMENT wp;\
	if (GetWindowPlacement (&wp) == TRUE)\
		{\
		wp.rcNormalPosition.left++;\
		if (SetWindowPlacement (&wp))\
				{\
			wp.rcNormalPosition.left--; \
			SetWindowPlacement (&wp);\
				}\
		}\
}


#define SHOW_V_SCROLL_BAR \
{\
	DWORD style = WS_VSCROLL;\
	ModifyStyle (0,style);\
	WINDOWPLACEMENT wp;\
	if (GetWindowPlacement (&wp) == TRUE)\
	{\
		wp.rcNormalPosition.left++;\
		if (SetWindowPlacement (&wp))\
		{\
			wp.rcNormalPosition.left--; \
			SetWindowPlacement (&wp);\
		}\
	}\
}

#define HIDE_V_SCROLL_BAR \
{\
	ModifyStyle(WS_VSCROLL, 0, SWP_NOZORDER); \
	WINDOWPLACEMENT wp; \
	if (GetWindowPlacement(&wp) == TRUE)\
	{\
		wp.rcNormalPosition.left++; \
		if (SetWindowPlacement(&wp))\
		{\
			wp.rcNormalPosition.left--; \
			SetWindowPlacement(&wp); \
		}\
	}\
}

#define WorkbenchLib_ZOOM_IN \
{\
	BOOL b_InitialFS = FALSE;\
	if (m_fract.left_fract() == 0 && m_fract.right_fract() == 1)\
		b_InitialFS = TRUE;\
		\
	double fs_horz = m_fract.right_fract() - m_fract.left_fract();\
	fs_horz /= 2.0;\
	\
	m_fract.SetLeft(m_cursor_x_fract - fs_horz / 2.0,false);\
	if (m_fract.left_fract() < 0.0)\
		m_fract.SetLeft(0.0,false);\
	m_fract.SetRight(m_fract.left_fract() + fs_horz,false);\
	\
	if (m_fract.right_fract() > 1.0)\
	{\
		m_fract.SetRight(1.0,false);\
		m_fract.SetLeft(1.0 - fs_horz,false);\
	}\
	\
	double fs_vert = m_fract.bottom_fract() - m_fract.top_fract();\
	fs_vert /= 2.0;\
	\
	m_fract.SetTop(m_cursor_y_fract - fs_vert / 2.0,false);\
	if (m_fract.top_fract() < 0.0)\
		m_fract.SetTop(0.0,false);\
	m_fract.SetBottom(m_fract.top_fract() + fs_vert,false);\
	\
	if (m_fract.bottom_fract() > 1.0)\
	{\
		m_fract.SetBottom(1.0,false);\
		m_fract.SetTop(1.0 - fs_vert,false);\
	}\
	\
	if (b_InitialFS)\
	SHOW_SCROLL_BARS\
	\
	Invalidate(FALSE);\
	m_need_to_render = true;\
}

#define WorkbenchLib_ZOOM_OUT\
	{\
		double fs_vert = m_fract.bottom_fract() - m_fract.top_fract(); \
		double fs_horz = m_fract.right_fract() - m_fract.left_fract(); \
		\
		if (fs_horz == 1.0 && fs_vert == 1.0)\
			return; \
			\
		fs_horz *= 2.0; \
		\
		if (fs_horz > 1.0)\
			fs_horz = 1.0; \
		\
		m_fract.SetLeft(m_cursor_x_fract - fs_horz / 2.0,false); \
		if (m_fract.left_fract() < 0.0)\
			m_fract.SetLeft(0.0,false); \
		m_fract.SetRight(m_fract.left_fract() + fs_horz,false); \
		\
		if (m_fract.right_fract() > 1.0)\
		{\
			m_fract.SetRight(1.0,false); \
			m_fract.SetLeft(1.0 - fs_horz,false); \
		}\
		\
		fs_vert *= 2.0; \
		\
		if (fs_vert > 1.0)\
			fs_vert = 1.0; \
		\
		m_fract.SetTop(m_cursor_y_fract - fs_vert / 2.0); \
		if (m_fract.top_fract() < 0.0)\
			m_fract.SetTop(0.0,false); \
		m_fract.SetBottom(m_fract.top_fract() + fs_vert,false); \
		\
		if (m_fract.bottom_fract() > 1.0)\
		{\
			m_fract.SetBottom(1.0,false); \
			m_fract.SetTop(1.0 - fs_vert,false); \
		}\
		\
		Invalidate(FALSE); \
		\
		m_need_to_render = true; \
		\
		if (m_fract.left_fract() == 0 && m_fract.right_fract() == 1)\
		{\
		HIDE_SCROLL_BARS\
		}\
	}

#define WorkbenchLib_UPDATE_SCROLL_POS\
	{\
		int pos_horz;\
		double left_side = m_fract.left_fract();\
		double right_side = 1.0 - m_fract.right_fract();\
		if (right_side == 0 && left_side == 0)\
			pos_horz = 500; \
		else\
			if (right_side == 0)\
				pos_horz = 1000; \
			else\
				if (left_side == 0)\
					pos_horz = 0; \
				else\
					pos_horz = (int)(1000.0 * (left_side / (left_side + right_side))); \
\
		SetScrollPos(SB_HORZ, pos_horz);\
	}\
	\
	{\
		int pos_vert;\
		double top_side = m_fract.top_fract();\
		double bottom_side = 1.0 - m_fract.bottom_fract();\
		if (bottom_side == 0 && top_side == 0)\
			pos_vert = 500; \
		else\
			if (bottom_side == 0)\
				pos_vert = 1000; \
			else\
				if (top_side == 0)\
					pos_vert = 0; \
				else\
					pos_vert = (int)(1000.0 * (top_side / (top_side + bottom_side))); \
\
		SetScrollPos(SB_VERT, pos_vert);\
	}


#define WorkbenchLib_ON_VSCROLL \
	if (nSBCode == SB_LINEDOWN)\
	{\
		if (m_fract.bottom_fract() == 1)\
			return;\
			\
		double fract = m_fract.bottom_fract() - m_fract.top_fract();\
		m_fract.AddToBottom(fract*0.1);\
		if (m_fract.bottom_fract() > 1.0)\
			m_fract.SetBottom(1.0);\
		m_fract.SetTop(m_fract.bottom_fract() - fract);\
		\
		Invalidate(FALSE);\
		m_need_to_render = TRUE;\
		\
		return;\
	}\
	if (nSBCode == SB_PAGEDOWN)\
	{\
		if (m_fract.bottom_fract() == 1)\
			return;\
\
		double fract = m_fract.bottom_fract() - m_fract.top_fract();\
		m_fract.AddToBottom(fract*0.90);\
		if (m_fract.bottom_fract() > 1.0)\
			m_fract.SetBottom(1.0);\
		m_fract.SetTop(m_fract.bottom_fract() - fract);\
		\
		Invalidate(FALSE);\
		m_need_to_render = TRUE;\
		\
		return;\
	}\
	\
	if (nSBCode == SB_LINEUP)\
	{\
		if (m_fract.top_fract() == 0)\
			return;\
			\
		double fract = m_fract.bottom_fract() - m_fract.top_fract();\
		m_fract.SubtractFromTop(fract*0.1);\
		if (m_fract.top_fract() < 0)\
			m_fract.SetTop(0);\
		m_fract.SetBottom(m_fract.top_fract() + fract);\
		\
		Invalidate(FALSE);\
		m_need_to_render = TRUE;\
		\
		return;\
	}\
	\
	if (nSBCode == SB_PAGEUP)\
	{\
		if (m_fract.top_fract() == 0)\
			return;\
\
		double fract = m_fract.bottom_fract() - m_fract.top_fract();\
		m_fract.SubtractFromTop(fract*0.90);\
		if (m_fract.top_fract() < 0)\
			m_fract.SetTop(0);\
		m_fract.SetBottom(m_fract.top_fract() + fract);\
		\
		Invalidate(FALSE);\
		m_need_to_render = TRUE;\
		\
		return;\
	}\
	\
	if (nSBCode == SB_THUMBPOSITION)\
	{\
		double fract = m_fract.bottom_fract() - m_fract.top_fract();\
		\
		if (nPos == 0)\
		{\
			m_fract.SetTop(0);\
			m_fract.SetBottom(m_fract.top_fract() + fract);\
		}\
		else\
			if (nPos == 1000)\
			{\
				m_fract.SetBottom(1.0);\
				m_fract.SetTop(m_fract.bottom_fract() - fract);\
			}\
			else\
			{\
				double range = m_fract.bottom_fract() - m_fract.top_fract();\
				double top_side = (double)nPos / 1000.0;\
				\
				top_side *= (1.0 - range);\
				\
				m_fract.SetTop(top_side);\
				m_fract.SetBottom(top_side + range);\
			}\
			\
		Invalidate(FALSE);\
		m_need_to_render = TRUE;\
	}

#define WorkbenchLib_ON_HSCROLL \
if (nSBCode == SB_LINEDOWN)\
{\
	if (m_fract.right_fract() == 1)\
		return;\
		\
	double fract = m_fract.right_fract() - m_fract.left_fract();\
	m_fract.AddToRight(fract*0.1);\
	if (m_fract.right_fract() > 1.0)\
		m_fract.SetRight(1.0);\
	m_fract.SetLeft(m_fract.right_fract() - fract);\
	\
	Invalidate(FALSE);\
	m_need_to_render = TRUE;\
	\
	return;\
}\
\
if (nSBCode == SB_PAGEDOWN)\
{\
	if (m_fract.right_fract() == 1)\
		return;\
\
	double fract = m_fract.right_fract() - m_fract.left_fract();\
	m_fract.AddToRight(fract*0.9);\
	if (m_fract.right_fract() > 1.0)\
		m_fract.SetRight(1.0);\
	m_fract.SetLeft(m_fract.right_fract() - fract);\
	\
	Invalidate(FALSE);\
	m_need_to_render = TRUE;\
	\
	return;\
}\
\
if (nSBCode == SB_LINEUP)\
{\
	if (m_fract.left_fract() == 0)\
		return;\
		\
	double fract = m_fract.right_fract() - m_fract.left_fract();\
	m_fract.SubtractFromLeft(fract*0.1);\
	if (m_fract.left_fract() < 0)\
		m_fract.SetLeft(0);\
	m_fract.SetRight(m_fract.left_fract() + fract);\
	\
	Invalidate(FALSE);\
	m_need_to_render = TRUE;\
	\
	return;\
}\
\
if (nSBCode == SB_PAGEUP)\
{\
	if (m_fract.left_fract() == 0)\
		return;\
		\
	double fract = m_fract.right_fract() - m_fract.left_fract();\
	m_fract.SubtractFromLeft(fract*0.9);\
	if (m_fract.left_fract() < 0)\
		m_fract.SetLeft(0);\
	m_fract.SetRight(m_fract.left_fract() + fract);\
	\
	Invalidate(FALSE);\
	m_need_to_render = TRUE;\
	\
	return;\
}\
\
if (nSBCode == SB_THUMBPOSITION)\
{\
	double fract = m_fract.right_fract() - m_fract.left_fract();\
	\
	if (nPos == 0)\
	{\
		m_fract.SetLeft(0);\
		m_fract.SetRight(m_fract.left_fract() + fract);\
	}\
	else\
		if (nPos == 1000)\
		{\
			m_fract.SetRight(1.0);\
			m_fract.SetLeft(m_fract.right_fract() - fract);\
		}\
		else\
		{\
			double range = m_fract.right_fract() - m_fract.left_fract();\
			double left_side = (double)nPos / 1000.0;\
			\
			left_side *= (1.0 - range);\
			\
			m_fract.SetLeft(left_side);\
			m_fract.SetRight(left_side + range);\
		}\
		\
	Invalidate(FALSE);\
	m_need_to_render = TRUE;\
}

#define Workbench_ON_CHANGE_SCALING \
RECT client_rect;\
GetClientRect(&client_rect);\
int width = client_rect.right - client_rect.left + 1;\
int height = client_rect.bottom - client_rect.top + 1;\
\
double horz_ratio = (ncols * m_fract.Width()) / width;\
double vert_ratio = (nrows * m_fract.Height()) / height;\
\
if (fabs(vert_ratio - horz_ratio) > 0.001)\
{\
	if (vert_ratio < horz_ratio)\
	{\
		double ratio = horz_ratio;\
		double f = ratio * height;\
		f /= nrows;\
		\
		double delta = (m_fract.Height() - f) / 2;\
		\
		double top = m_fract.top_fract() + delta;\
		double bottom = m_fract.bottom_fract() - delta;\
		\
		double h = bottom - top;\
		\
		bottom = 0.5 + h / 2;\
		top = 0.5 - h / 2;\
		\
		m_fract.SetTop(top, false);\
		m_fract.SetBottom(bottom, false);\
	}\
	else\
		if (horz_ratio < vert_ratio)\
		{\
			double ratio = vert_ratio;\
			double f = ratio * width;\
			f /= ncols;\
			\
			double delta = (m_fract.Width() - f) / 2;\
			\
			double left = m_fract.left_fract() + delta;\
			double right = m_fract.right_fract() - delta;\
			\
			double w = right - left;\
			\
			right = 0.5 + w / 2;\
			left = 0.5 - w / 2;\
			\
			m_fract.SetLeft(left, false);\
			m_fract.SetRight(right, false);\
		}\
}\
\
/*clean up over compression */\
double w = m_fract.Width();\
double h = m_fract.Height();\
\
if (w > 1.001 && h > 1.001)\
{\
	double scale;\
	if (w < h)\
	{\
		scale = h / w;\
		m_fract.SetLeft(0);\
		m_fract.SetRight(1);\
		\
		scale -= 1;\
		m_fract.SetTop(-scale / 2, false);\
		m_fract.SetBottom(1 + scale / 2, false);\
	}\
	else\
	{\
		scale = w / h;\
		m_fract.SetTop(0);\
		m_fract.SetBottom(1);\
		\
		scale -= 1;\
		m_fract.SetLeft(-scale / 2, false);\
		m_fract.SetRight(1 + scale / 2, false);\
	}\
}

#include "io.h"
#include "stdio.h"
inline bool CanWriteToFile(const char *file_name)
{
	FILE *stream = 0;
	if (_access(file_name, 00) == 0)
	{
		// File exists
		fopen_s(&stream, file_name, "w+b");
		if (stream == 0)
			return false;
		fclose(stream);
		return true;
	}
	else
	{
		fopen_s(&stream, file_name, "wb");
		if (stream == 0)
			return false;
		fclose(stream);
		_unlink(file_name);
		return true;
	}
}

#define RESET_TIMER_1000(IDC) { KillTimer(IDC); SetTimer(IDC,1000,NULL); }

inline void RST_h(HWND hWnd, UINT IDC, UINT ms)
{
	KillTimer(hWnd, IDC);
	SetTimer(hWnd, IDC, ms, NULL);
}